/*
 * Created on 23-jun-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.ossim.graph.applet;

import javax.swing.JApplet;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;

import java.net.MalformedURLException;
import java.net.URL;
import java.io.IOException;
import java.io.InputStream;

import org.jfree.data.xml.DatasetReader;
import org.jfree.data.CategoryDataset;
import org.jfree.data.PieDataset;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PiePlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.renderer.BarRenderer3D;


/**
 * @author fot
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OssimGraphApplet extends JApplet {
	private String GRAPH_TYPE_AREA = "Area";
	private String GRAPH_TYPE_BAR = "Bar";
	private String GRAPH_TYPE_BAR3D = "Bar3D";
	private String GRAPH_TYPE_PIE = "Pie";
	private String GRAPH_TYPE_PIE3D = "Pie3D";
	private String GRAPH_TYPE_LINE = "Line";
	private String GRAPH_TYPE_STACKED_AREA = "StackedArea";
	private String GRAPH_TYPE_STACKED_BAR = "StackedBar";
	private String GRAPH_TYPE_STACKED_BAR3D = "StackedBar3D";
	
	private String graphType;
	private String xmlDataUrl;

	private String title;
	private String categoryAxisLabel;
	private String valueAxisLabel;
	private Boolean legend = Boolean.TRUE;
	private Boolean tooltips = Boolean.TRUE;
	private Boolean urls = Boolean.FALSE;
	
	private Float alpha = null;
	private PlotOrientation orientation = PlotOrientation.VERTICAL;
	private Boolean rotate = Boolean.FALSE;
	private Boolean render = Boolean.FALSE;

	private void loadAppletParameters() {
		String value;
		
		graphType = getParameter("graphType");
		xmlDataUrl = getParameter("xmlDataUrl");

		title = getParameter("title");
		categoryAxisLabel = getParameter("categoryAxisLabel");
		valueAxisLabel = getParameter("valueAxisLabel");

		value = getParameter("legend");
		if (value != null) {
			if (value.compareToIgnoreCase("TRUE") == 0)
				legend = Boolean.TRUE;
			else if (value.compareToIgnoreCase("FALSE") == 0)
				legend = Boolean.FALSE;
		}
		value = getParameter("tooltips");
		if (value != null) {
			if (value.compareToIgnoreCase("TRUE") == 0)
				tooltips = Boolean.TRUE;
			else if (value.compareToIgnoreCase("FALSE") == 0)
				tooltips = Boolean.FALSE;
		}
		value = getParameter("urls");
		if (value != null) {
			if (value.compareToIgnoreCase("TRUE") == 0)
				urls = Boolean.TRUE;
			else if (value.compareToIgnoreCase("FALSE") == 0)
				urls = Boolean.FALSE;
		}
		
		if (getParameter("alpha") != null)
			alpha = Float.valueOf(getParameter("alpha"));

		value = getParameter("rotate");
		if (value != null) {
			if (value.compareToIgnoreCase("TRUE") == 0)
				rotate = Boolean.TRUE;
			else if (value.compareToIgnoreCase("FALSE") == 0)
				rotate = Boolean.FALSE;
		}

		value = getParameter("orientation");
		if (value != null) {
			if (value.compareToIgnoreCase("VERTICAL") == 0)
				orientation = PlotOrientation.VERTICAL;
			else if (value.compareToIgnoreCase("HORIZONTAL") == 0)
				orientation = PlotOrientation.HORIZONTAL;
		}

		value = getParameter("render");
		if (value != null) {
			if (value.compareToIgnoreCase("TRUE") == 0)
				render = Boolean.TRUE;
			else if (value.compareToIgnoreCase("FALSE") == 0)
				render = Boolean.FALSE;
		}
}

	private CategoryDataset getCategoryDataset() {
		CategoryDataset dataset = null;
		try {
			URL url = new URL(xmlDataUrl);
			InputStream in = url.openStream();
			dataset = DatasetReader.readCategoryDatasetFromXML(in);
		} catch (MalformedURLException e)  {
			System.out.println(e);
		} catch (IOException e)  {
			System.out.println(e);
		}
		return dataset;
	}
	
	private PieDataset getPieDataset() {
		PieDataset dataset = null;
		try {
			URL url = new URL(xmlDataUrl);
			InputStream in = url.openStream();
			dataset = DatasetReader.readPieDatasetFromXML(in);
		} catch (MalformedURLException e)  {
			System.out.println(e);
		} catch (IOException e)  {
			System.out.println(e);
		}
		return dataset;
	}

	private void createAreaGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createAreaChart(title, 
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		if (alpha != null) {
			final CategoryPlot plot = chart.getCategoryPlot();
			plot.setForegroundAlpha(alpha.floatValue());
		}
        
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	private void createBarGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createBarChart(title,
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());
		
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}
	
	private void createBar3DGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createBarChart3D(title,
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		final CategoryPlot plot = chart.getCategoryPlot();
		if (render != null) {
			final BarRenderer3D renderer = (BarRenderer3D) plot.getRenderer();
			renderer.setDrawBarOutline(false);
		}
		
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	
	private void createPieGraph() {
		PieDataset dataset = getPieDataset ();
        JFreeChart chart = ChartFactory.createPieChart(title,
				dataset, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

    	final PiePlot plot = (PiePlot) chart.getPlot();

        if (alpha != null) {
        	plot.setForegroundAlpha(alpha.floatValue());
        }
        if (rotate.booleanValue()) {
        	Rotator rotator = new Rotator(plot);
            rotator.start();        	
        }
        
        ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}
	
	private void createPie3DGraph() {
		PieDataset dataset = getPieDataset ();
        JFreeChart chart = ChartFactory.createPieChart3D(title,
				dataset, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

    	final PiePlot plot = (PiePlot) chart.getPlot();

        if (alpha != null) {
        	plot.setForegroundAlpha(alpha.floatValue());
        }
        if (rotate.booleanValue()) {
        	Rotator rotator = new Rotator(plot);
            rotator.start();        	
        }

        ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	private void createLineGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createLineChart(title, 
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		if (alpha != null) {
			final CategoryPlot plot = chart.getCategoryPlot();
			plot.setForegroundAlpha(alpha.floatValue());
		}
        
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	private void createStackedAreaGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createStackedAreaChart(title, 
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		if (alpha != null) {
			final CategoryPlot plot = chart.getCategoryPlot();
			plot.setForegroundAlpha(alpha.floatValue());
		}
        
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	private void createStackedBarGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createStackedBarChart(title, 
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		if (alpha != null) {
			final CategoryPlot plot = chart.getCategoryPlot();
			plot.setForegroundAlpha(alpha.floatValue());
		}
        
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	private void createStackedBar3DGraph() {
		CategoryDataset dataset = getCategoryDataset ();
		JFreeChart chart = ChartFactory.createStackedBarChart3D(title, 
				categoryAxisLabel, 
				valueAxisLabel, 
				dataset, 
				orientation, 
				legend.booleanValue(), 
				tooltips.booleanValue(), 
				urls.booleanValue());

		if (alpha != null) {
			final CategoryPlot plot = chart.getCategoryPlot();
			plot.setForegroundAlpha(alpha.floatValue());
		}
        
		ChartPanel panel = new ChartPanel (chart);
		getContentPane().add(panel);
	}

	public void init() {
		loadAppletParameters ();

		if (graphType.compareToIgnoreCase(GRAPH_TYPE_AREA) == 0) {
			createAreaGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_BAR) == 0) {
			createBarGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_BAR3D) == 0) {
			createBar3DGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_PIE) == 0) {
			createPieGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_PIE3D) == 0) {
			createPie3DGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_LINE) == 0) {
			createLineGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_STACKED_AREA) == 0) {
			createStackedAreaGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_STACKED_BAR) == 0) {
			createStackedBarGraph();
		} else if (graphType.compareToIgnoreCase(GRAPH_TYPE_STACKED_BAR3D) == 0) {
			createStackedBar3DGraph();
		}
	}

    public String[][] getParameterInfo() {
        String[][] info = {
        		{"graphType", "string", "Graph type"},
				{"xmlDataType", "string", "URL of the xml data file"},
				{"title", "string", "Graph Title"},
				{"categoryAxisLabel", "string", "Title for X axis"},
				{"valueAxisLabel", "string", "Title for Y axis"},
				{"legend", "boolean", "a flag specifying whether or not a legend is required"},
				{"tooltips", "boolean", "configure chart to generate tool tips?"},
				{"urls", "boolean", "configure chart to generate URLs?"},
				{"alpha", "string", "Sets the alpha-transparency for the plot"},
				{"rotate", "boolean", "rotation effect"},
				{"orientation", "string", "the plot orientation HORIZONTAL or VERTICAL"},
				{"render", "boolean", "Render option for Bar3D"}
          		};
        return info;
    }

    /**
     * The rotator.
     *
     */
    static class Rotator extends Timer implements ActionListener {

        /** The plot. */
        private PiePlot plot;

        /** The angle. */
        private int angle = 270;

        /**
         * Constructor.
         *
         * @param plot  the plot.
         */
        Rotator(final PiePlot plot) {
            super(100, null);
            this.plot = plot;
            addActionListener(this);
        }

        /**
         * Modifies the starting angle.
         *
         * @param event  the action event.
         */
        public void actionPerformed(final ActionEvent event) {
            this.plot.setStartAngle(angle);
            this.angle = this.angle + 1;
            if (this.angle == 360) {
                this.angle = 0;
            }
        }
                                                                                                                                            
    }
    
}
