package net.ossim.scanmap;

import javax.swing.JApplet;

public class OssimScanMap3DApplet extends JApplet {
    /* Opciones de configuracion incluidas el acceso a la BD si corresponde */
    private String dataUrl = null;
    /* Origen de datos del fichero */
    private String textFileDataUrl = null;
    /* Flag que determina si se inicia el play automaticamente */
    private boolean isAutorunning = false;


    private void loadAppletParameters() {
	dataUrl = getParameter("dataUrl");
	textFileDataUrl = getParameter("textFileDataUrl");
        isAutorunning = getParameter("autorun") != null && "yes".equals(getParameter("autorun"));
    }

    public void init() {
	loadAppletParameters ();

	if (dataUrl == null){
          return;
        }

	scanmap3d scanmap = new scanmap3d(dataUrl,textFileDataUrl);

        scanmap.setLocation(0,0);
        scanmap.show();

        tools_window toolWindow = new tools_window(scanmap);
        /* Mantenemos una referencia de una ventana a la otra */
        scanmap.my_tool_window = toolWindow;

        toolWindow.setLocation(0,450);
        toolWindow.show();

        /* Hace que arranque automaticamente segn flag*/
        if (isAutorunning){
          scanmap.isrunning = true;
          toolWindow.scanmap_link.view3d.play();
        }
    }

    public String[][] getParameterInfo() {
        String[][] info = {
	    {"dataUrl", "string", "URL of the data file"}
	};
        return info;
    }
  public String getTextFileDataUrl() {
    return textFileDataUrl;
  }
  public void setTextFileDataUrl(String textFileDataUrl) {
    this.textFileDataUrl = textFileDataUrl;
  }
}
