package net.ossim.scanmap.dao;

import java.util.*;

import net.ossim.scanmap.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.swing.ProgressMonitor;
import net.ossim.util.DateUtils;
import java.net.*;

public class ScanMapDAOMysqlImpl implements ScanMapDAO {

  private int packetCount;
  private Timestamp null_time = new java.sql.Timestamp(0);
  private Connection con;
  private String urlTextFile;
  private scanmap3d thisScanmap;





  /** Creates a new instance of database_link */
  public ScanMapDAOMysqlImpl(String sqlurl, String sqllogin, String sqlpasswd,scanmap3d in_scanmap) {
      thisScanmap=in_scanmap;
      packetCount = 0;
      null_time = new java.sql.Timestamp(0);
      // Load the Driver Connection
      try {
          Class.forName("org.gjt.mm.mysql.Driver").newInstance();
      }
      catch (Exception e){
          System.out.println("Database Driver Problem");
          System.out.println(e.getMessage());
      }
      // Establish the connection
      try {
          con = DriverManager.getConnection(sqlurl,sqllogin,sqlpasswd);
      }
      catch (Exception e){
          System.out.println("Database Connection Problem");
          System.out.println(e.getMessage());
          System.out.println(e.getLocalizedMessage());
          e.printStackTrace();
      }
  }

  public int packetcount(int in_count){

      int pcount=0;
      boolean success=false;
      try {
          Statement stmt;
          stmt = con.createStatement();
          String getcount = "SELECT count(distinct event.sid,event.cid) from event,iphdr ";
                  boolean active_filters=false;

          if (thisScanmap.filterswitch){
                      DatabaseFilter filter_temp = thisScanmap.dbfilter;
                      // Select which tables we need
                      if (!filter_temp.dst_port.equals("null") || !filter_temp.src_port.equals("null")){
                              getcount = getcount.concat(",tcphdr,udphdr");
                              active_filters=true;
                      }
                      if ((!filter_temp.dst_ip.equals("null")||!filter_temp.src_ip.equals("null")
                              ||!filter_temp.protocol.equals("null"))){
                              active_filters=true;
                      }
                      if (!filter_temp.priority.equals("null")){
                              getcount = getcount.concat(",signature");
                              active_filters=true;
                      }

                      if (!filter_temp.time_start.equals(null_time) ||
                              !filter_temp.time_finish.equals(null_time)){
                              active_filters=true;
                      }

                      if (active_filters){
                              getcount = getcount.concat(" where ");
                              boolean previous = false;
                              if (!thisScanmap.dbfilter.src_ip.equals("null")){
                                      getcount = getcount.concat(
                                          " inet_ntoa(iphdr.ip_src)=\"" +
                                      thisScanmap.dbfilter.src_ip + "\" ");
                                      previous=true;
                              }
                              if (!thisScanmap.dbfilter.dst_ip.equals("null")){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" inet_ntoa(iphdr.ip_dst)=\" " +
                                          thisScanmap.dbfilter.dst_ip + "\" ");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.dst_port.equals("null")){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" ((tcphdr.tcp_dport"+
                                      thisScanmap.dbfilter.dst_port+
                                      " and event.cid=tcphdr.cid and event.sid=tcphdr.sid) or " +
                                      " (udphdr.udp_dport" + thisScanmap.dbfilter.dst_port +
                                      " and event.cid=udphdr.cid and event.sid=udphdr.cid " +
                                      "))");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.src_port.equals("null")){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" ((tcphdr.tcp_sport  " +
                                               thisScanmap.dbfilter.src_port +
                                      " and event.cid=tcphdr.cid and event.sid=tcphdr.sid) or " +
                                      " (udphdr.udp_sport" + thisScanmap.dbfilter.src_port +
                                      " and event.cid=udphdr.cid and event.sid=udphdr.cid " +
                                      "))");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.priority.equals("null")){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" signature.sig_priority "+		 							thisScanmap.dbfilter.priority +
                                              " and signature.sig_id=event.signature");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.time_start.equals(null_time)){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" event.timestamp >=\" " +
                                              thisScanmap.dbfilter.time_start+"\" ");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.time_finish.equals(null_time)){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" event.timestamp <=\" " +
                                              thisScanmap.dbfilter.time_finish+"\" ");
                                      previous = true;
                              }

                              if (!thisScanmap.dbfilter.protocol.equals("null")){
                                      if (previous){
                                              getcount = getcount.concat(" and ");
                                      }
                                      getcount = getcount.concat(" iphdr.ip_proto" +
                                              thisScanmap.dbfilter.protocol);
                                      previous = true;
                              }
                              getcount = getcount.concat(" and event.cid=iphdr.cid and event.sid=iphdr.sid;");

                      } else {
                              getcount = getcount.concat(" where event.cid=iphdr.cid and event.sid=iphdr.sid;");
                      }

          }
          else {
              getcount = getcount.concat("where event.cid=iphdr.cid and event.sid=iphdr.sid;");
          }
          //System.out.println(getcount);

          ResultSet result = stmt.executeQuery(getcount);

          if (result==null){
                              System.out.println("Null result from count:"+getcount);
          }

          result.first();
          pcount = result.getInt("count(distinct event.sid,event.cid)");
          stmt.close();
          packetCount = pcount;
          success=true;
      }
      catch (Exception e){
          System.out.println("Error Accessing Database for Count");
          System.out.println(e.getMessage());
                      System.out.println(e.getLocalizedMessage());
          success=false;

      }
      if (success){
          return pcount;
      }
      else{
          return in_count;
      }
  }

  public void getHostStats(host3d host_in,host_stats stats_in){

      // Collect the stats for a single host

      try {
          Statement stmt;
          stmt = con.createStatement();
              // query the number of alerts were this host is the source

          String srcresultcount = "SELECT COUNT(DISTINCT signature) from event,iphdr " +
              "WHERE inet_ntoa(iphdr.ip_src)=\"" + host_in.host_ip +
                              "\" and iphdr.sid=event.sid and iphdr.cid=event.cid;";
          String getsrccount = "SELECT DISTINCT signature.sig_name,count(signature)"+
                              " from event,iphdr,signature " +
              "WHERE inet_ntoa(iphdr.ip_src)=\"" + host_in.host_ip +
                              "\" and iphdr.sid=event.sid and iphdr.cid=event.cid " +
              " and signature.sig_id=signature group by signature;";
          ResultSet result_count = stmt.executeQuery(srcresultcount);

          result_count.first();

          int src_results = result_count.getInt("count(distinct signature)");
          if (src_results!=0){
              ResultSet result = stmt.executeQuery(getsrccount);
              result.first();
              for (int i=0; i<src_results;i++){
                  String sig_string =result.getString("signature.sig_name");
                  String sig_count = result.getString("count(signature)");
                  stats_in.add_src_stat(sig_string,sig_count);
                  if (!(i>=src_results-1)){
                      result.next();
                  }
              }
          }

          String dstresultcount = "SELECT COUNT(DISTINCT signature) from event,iphdr " +
              "WHERE inet_ntoa(iphdr.ip_dst)=\"" + host_in.host_ip +
                              "\" and iphdr.sid=event.sid and iphdr.cid=event.cid;";
          String getdstcount = "SELECT DISTINCT signature.sig_name,count(signature) "+
                              "from event,iphdr,signature " +
              "WHERE inet_ntoa(iphdr.ip_dst)=\"" + host_in.host_ip +
                              "\" and iphdr.sid=event.sid and iphdr.cid=event.cid " +
              " and signature.sig_id=signature group by signature;";

          ResultSet result_count2 = stmt.executeQuery(dstresultcount);
          result_count2.first();
          int dst_results = result_count2.getInt("count(distinct signature)");
          if (dst_results!=0){
              ResultSet result2 = stmt.executeQuery(getdstcount);
              result2.first();
              for (int i=0; i<dst_results;i++){

                  String sig_string = result2.getString("signature.sig_name");
                  String sig_count = result2.getString("count(signature)");

                  stats_in.add_dest_stat(sig_string,sig_count);
                  if (!(i>=dst_results-1)){
                      result2.next();
                  }
              }
          }

          stmt.close();
      }
      catch (Exception e){
          System.out.println("Error Accessing Database for Stats");
          System.out.println(e.getMessage());
      }
  }

      // Method to get a set number of packets from the database

      public void addPackets(Vector in_vector,int start,int finish){

          try{
              Statement stmt;
              stmt = con.createStatement();


              String getpacket = "SELECT event.cid,event.sid"+
                              ",event.timestamp,signature.sig_class_id,inet_ntoa(iphdr.ip_src)" +
                               ",inet_ntoa(iphdr.ip_dst),iphdr.ip_proto,iphdr.ip_len from event,iphdr,signature";
                              boolean active_filters=false;
              if (thisScanmap.filterswitch){
                  DatabaseFilter filter_temp = thisScanmap.dbfilter;

                  // Select which tables we need
                  if (!filter_temp.dst_port.equals("null")|| !filter_temp.src_port.equals("null")){
                      getpacket = getpacket.concat(",tcphdr,udphdr");
                                              active_filters=true;
                  }
                  if (!filter_temp.dst_ip.equals("null")||!filter_temp.src_ip.equals("null")
                      ||!filter_temp.protocol.equals("null")){
                                              active_filters=true;
                  }
                  if (!filter_temp.priority.equals("null")){
                          active_filters=true;
                  }
                  if (!filter_temp.time_start.equals(null_time) || !filter_temp.time_finish.equals(null_time)){
                          active_filters=true;
                  }

                  if (active_filters){

                      getpacket = getpacket.concat(" where ");
                      boolean previous = false;

                      if (!thisScanmap.dbfilter.src_ip.equals("null")){
                              getpacket = getpacket.concat(
                                      " inet_ntoa(iphdr.ip_src)=\"" + thisScanmap.dbfilter.src_ip + "\"");
                              previous=true;
                      }

                      if (!thisScanmap.dbfilter.dst_ip.equals("null")){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" inet_ntoa(iphdr.ip_dst)=\""
                                      + thisScanmap.dbfilter.dst_ip +"\"");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.dst_port.equals("null")){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat("( (tcphdr.tcp_dport  " +
                                      thisScanmap.dbfilter.dst_port +
                                      " and event.cid=tcphdr.cid and event.sid=tcphdr.sid) or " +
                                      " (udphdr.udp_dport" + thisScanmap.dbfilter.dst_port +
                                      " and event.cid=udphdr.cid and event.sid=udphdr.cid " +
                                      "))");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.src_port.equals("null")){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" ((tcphdr.tcp_sport  " +
                                                      thisScanmap.dbfilter.src_port +
                                      " and event.cid=tcphdr.cid and event.sid=tcphdr.sid) or " +
                                      " (udphdr.udp_sport" + thisScanmap.dbfilter.src_port +
                                      " and event.cid=udphdr.cid and event.sid=udphdr.cid " +
                                      "))");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.priority.equals("null")){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" signature.sig_priority "
                              + thisScanmap.dbfilter.priority +
                              " and signature.sig_id=event.signature");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.time_start.equals(null_time)){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" event.timestamp >= \"" +
                                      thisScanmap.dbfilter.time_start+"\" ");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.time_finish.equals(null_time)){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" event.timestamp <= \"" +
                                      thisScanmap.dbfilter.time_finish+"\" ");
                              previous = true;
                      }

                      if (!thisScanmap.dbfilter.protocol.equals("null")){
                              if (previous){
                                      getpacket = getpacket.concat(" and ");
                              }
                              getpacket = getpacket.concat(" iphdr.ip_proto" +
                                      thisScanmap.dbfilter.protocol);
                              previous = true;
                      }
                                              getpacket=getpacket.concat(" and iphdr.cid=event.cid and iphdr.sid=event.sid " +
                              "and event.signature=signature.sig_id ");

                  }
                  else {
                                              getpacket=getpacket.concat("  where iphdr.cid=event.cid and iphdr.sid=event.sid " +
                      "and event.signature=signature.sig_id ");
                                      }
                              }
              else{
                  getpacket=getpacket.concat(" where iphdr.cid=event.cid and iphdr.sid=event.sid "  +
                      "and event.signature=signature.sig_id ");
              }

          getpacket = getpacket.concat (" ORDER BY event.timestamp ASC LIMIT " + start + "," +finish + ";");
          //System.out.println(getpacket);
          ResultSet packet_event = stmt.executeQuery(getpacket);

          if (packet_event!=null){

              packet_event.first();
              ProgressMonitor prog_mon = new ProgressMonitor(null,"Loading Packets","Loading Packets",start,finish);
              prog_mon.setMillisToPopup(10);
              int prog=0;

              do{
                  prog_mon.setProgress(start+prog);
                  ip_packet inpacket = new ip_packet();
                  int sid = packet_event.getInt("event.sid");
                  int cid = packet_event.getInt("event.cid");
                  inpacket.timestamp = packet_event.getTimestamp("event.timestamp");
                  inpacket.type=packet_event.getInt("signature.sig_class_id");
                  inpacket.src_ip=packet_event.getString("inet_ntoa(iphdr.ip_src)");
                  inpacket.dst_ip=packet_event.getString("inet_ntoa(iphdr.ip_dst)");
                  inpacket.size=packet_event.getInt("iphdr.ip_len");
                  inpacket.protocol = packet_event.getInt("iphdr.ip_proto");
                  getPacketData(inpacket,sid,cid);
                  in_vector.addElement(inpacket);
                  prog++;
              }while (packet_event.next());
              prog_mon.close();
          }
          else{
              System.out.println("No Packets");
              return;
          }

          stmt.close();
          }catch(Exception e){
              System.out.println("Problem reading packets");
              System.out.println(e.getMessage());
          }
          System.gc();
      }

      public void getPacketData(ip_packet inpacket,int sid,int cid){
          try
          {
              Statement stmt;
              stmt = con.createStatement();
                  switch (inpacket.protocol) {
                      case    6:
                      {
                                              //System.out.println("tcp");
                          String tcpquery = "SELECT tcp_sport,tcp_dport,lpad(bin(tcp_flags),8" +",'0') "+
                              "FROM tcphdr WHERE cid = "+cid+" AND sid = "+sid+";";
                                              //System.out.println (tcpquery);
                          ResultSet tcpresult = stmt.executeQuery(tcpquery);
                          tcpresult.first();
                          inpacket.dst_port=tcpresult.getInt("tcp_dport");
                          inpacket.src_port=tcpresult.getInt("tcp_sport");
                          String flags_temp = tcpresult.getString("lpad(bin(tcp_flags),8" +",'0')");

                                          // convert the FLAGS to a String
                          String flagString="";
                                                 if (flags_temp.charAt(7)=='1'){
                                                      flagString =flagString.concat("F ");
                                          }
                                          if (flags_temp.charAt(6)=='1'){
                                                      flagString =flagString.concat("S ");
                                          }
                                          if (flags_temp.charAt(5)=='1'){
                                                      flagString =flagString.concat("R ");
                                          }
                                          if (flags_temp.charAt(4)=='1'){
                                              flagString =flagString.concat("P ");
                                          }
                                          if (flags_temp.charAt(3)=='1'){
                                                      flagString =flagString.concat("A ");
                                          }
                                          if (flags_temp.charAt(2)=='1'){
                                                      flagString =flagString.concat("U ");
                                          }
                                          if (flags_temp.charAt(1)=='1'){
                                                      flagString =flagString.concat("E ");
                                          }
                                          if (flags_temp.charAt(0)=='1'){
                                                      flagString =flagString.concat("C ");
                                          }
                                          if (flagString.length()==0){
                                                      flagString="no flags";
                                          }
                          inpacket.flags=flagString;
                                          //System.out.println(flagString +" "+flags_temp);

                          break;
                      }
                      case    1:
                      {
                                              //System.out.println("icmp");
                          String icmpquery = "SELECT icmp_type FROM icmphdr WHERE cid="+
                              cid+ " AND sid=" +sid+";";
                          ResultSet icmpresult = stmt.executeQuery(icmpquery);
                          icmpresult.first();
                          int icmp_type = icmpresult.getInt("icmp_type");
                          switch (icmp_type){
                              case 0:
                                  inpacket.flags = "Reply";
                                  break;
                              case 3:
                                  inpacket.flags = "Unreachable";
                                  break;
                              case 4:
                                  inpacket.flags = "Quench";
                                  break;
                              case 5:
                                  inpacket.flags = "Redirect";
                                  break;
                              case 8:
                                  inpacket.flags = "Echo";
                                  break;
                              case 11:
                                  inpacket.flags = "Timeout";
                                  break;
                              default:
                                  inpacket.flags = "Unknown";
                          }
                          inpacket.src_port=-1;
                          inpacket.dst_port=-1;
                          break;
                      }
                      case    17:
                      {
                                              //System.out.println("udp");
                          String udpquery = "SELECT udp_sport,udp_dport"+
                              " FROM udphdr WHERE cid = "+cid+" and sid="+sid+";";
                          ResultSet udpresult = stmt.executeQuery(udpquery);
                                          // test result
                                  if (udpresult==null){
                                                      System.out.println("Null result from udpquery:"+udpquery);
                                          }
                                  udpresult.first();
                      inpacket.dst_port=udpresult.getInt("udp_dport");
                      inpacket.src_port=udpresult.getInt("udp_sport");
                      break;
                      }
                  }

              stmt.close();

              }
              catch (Exception e){
                  System.out.println("Error Reading from Database");
                  System.out.println(e.getMessage());
              }


      }
  public int getPacketCount() {
    return packetCount;
  }
  public scanmap3d getThisScanmap() {
    return thisScanmap;
  }


}
