/* Scanmap is a 3d Visualisation for Snort alerts 
*   
*   Copyright (C) 2003 Daniel Clark
*
*	This program is free software; you can redistribute it and/or 
*	modify it under the terms of the GNU General Public License as 
*	published by the Free Software Foundation; either version 2 of 
*	the License, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful, 
*	but WITHOUT ANY WARRANTY; without even the implied warranty of 
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License 
*	along with this program; if not, write to the Free Software 
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*	
*	Contact: Daniel Clark 
*	Email:	scanmap3d@sourceforge.net
*	
*
*
* netlink3d.java
*
* Created on March 14, 2003, 12:28 PM
*/
package net.ossim.scanmap;


import java.lang.Math.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Cone;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Box;
import java.util.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.j3d.utils.timer.J3DTimer;
import java.awt.*;

public class netlink3d extends javax.media.j3d.TransformGroup {
    
    
    public net3dapp texture_lib;
    public host3d host1,host2;
    public int port1,port2;
    public float width;
    public Appearance app;
    public int number;
    
    public netlink3d(net3dapp in_apps) {
        texture_lib = in_apps;
    }
                
    /** Creates a new instance of pipe3d */
        public netlink3d(host3d inhost2, host3d inhost1, ip_packet inpacket,net3dapp in_apps) {
            
        texture_lib = in_apps;
        this.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
        this.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
        this.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        this.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        this.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            
        host1=inhost1;
        host2=inhost2;
        port1=inpacket.src_port;
        port2=inpacket.dst_port;            
        
        port3d port13d = new port3d(texture_lib);
        port3d port23d = new port3d(texture_lib);
        TransformGroup port1tg = new TransformGroup();
        TransformGroup port2tg = new TransformGroup();            
        TransformGroup host1g = new TransformGroup();
        TransformGroup host2g = new TransformGroup();
        host1g = (TransformGroup) host1.getChild(0);
        host2g = (TransformGroup) host2.getChild(0);
        Transform3D hosttrans1 = new Transform3D();
        Transform3D hosttrans2 = new Transform3D();
        Transform3D hosttrans1g = new Transform3D();
        Transform3D hosttrans2g = new Transform3D();   
        Transform3D porttrans1 = new Transform3D();
        Transform3D porttrans2 = new Transform3D();
        Vector3f hostvector1 = new Vector3f();
        Vector3f hostvector2 = new Vector3f();
        Vector3f portvector1 = new Vector3f();
        Vector3f portvector2 = new Vector3f();
        Vector3f nullvector = new Vector3f(0.0f,0.0f,0.0f);
        Vector3f linkvector1 = new Vector3f();
        Vector3f linkvector2 = new Vector3f();             
        host1.getTransform(hosttrans1);
        host2.getTransform(hosttrans2);                                
        host1g.getTransform(hosttrans1g);
        host2g.getTransform(hosttrans2g);
        hosttrans1.get(hostvector1);
        hosttrans2.get(hostvector2);                                     
        
        if (inpacket.src_port == -1||inpacket.dst_port==-1){
            hosttrans1.mul(hosttrans1g);
            hosttrans2.mul(hosttrans2g);
            hosttrans1.get(hostvector1);
            hosttrans2.get(hostvector2);             
            linkvector1 = hostvector1;
            linkvector2 = hostvector2;
        }
        else {
            port13d = (port3d) host1.getPort(port1);
            port23d = (port3d) host2.getPort(port2);                
            port1tg = (TransformGroup) port13d.getChild(0);
            port2tg = (TransformGroup) port23d.getChild(0);        
            port1tg.getTransform(porttrans1);
            port2tg.getTransform(porttrans2);
            porttrans1.get(portvector1);
            porttrans2.get(portvector2);
            hosttrans1.mul(porttrans1);
            hosttrans2.mul(porttrans2);
            hosttrans1.get(linkvector1);
            hosttrans2.get(linkvector2);   
            
        }
        
        
        BoundingSphere bounds =
	    new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
                       
        pipe3d pipe = new pipe3d(linkvector1,linkvector2,0.05f,texture_lib.getAppearance(3));

        this.addChild(pipe);
    }
    
    public void updateLink() {
        port3d port13d = new port3d(texture_lib);
        port3d port23d = new port3d(texture_lib);
        TransformGroup port1tg = new TransformGroup();
        TransformGroup port2tg = new TransformGroup();
        TransformGroup host1g = new TransformGroup();
        TransformGroup host2g = new TransformGroup();
        host1g = (TransformGroup) host1.getChild(0);
        host2g = (TransformGroup) host2.getChild(0);
        Transform3D hosttrans1 = new Transform3D();
        Transform3D hosttrans2 = new Transform3D();
        Transform3D hosttrans1g = new Transform3D();
        Transform3D hosttrans2g = new Transform3D();       
        Transform3D porttrans1 = new Transform3D();
        Transform3D porttrans2 = new Transform3D();
        Vector3f hostvector1 = new Vector3f();
        Vector3f hostvector2 = new Vector3f();
        Vector3f portvector1 = new Vector3f();
        Vector3f portvector2 = new Vector3f();
        Vector3f nullvector = new Vector3f(0.0f,0.0f,0.0f);
        Vector3f linkvector1 = new Vector3f();
        Vector3f linkvector2 = new Vector3f();
        host1.getTransform(hosttrans1);
        host2.getTransform(hosttrans2);                                
        host1g.getTransform(hosttrans1g);
        host2g.getTransform(hosttrans2g);
        hosttrans1.get(hostvector1);
        hosttrans2.get(hostvector2);  
   
        if ((this.port1 == -1)||(this.port2== -1)){
            hosttrans1.mul(hosttrans1g);
            hosttrans2.mul(hosttrans2g);
            hosttrans1.get(hostvector1);
            hosttrans2.get(hostvector2);             
            linkvector1 = hostvector1;
            linkvector2 = hostvector2;
        }
        else {
            port13d = (port3d) host1.getPort(port1);
            port23d = (port3d) host2.getPort(port2);                
            port1tg = (TransformGroup) port13d.getChild(0);
            port2tg = (TransformGroup) port23d.getChild(0);        
            port1tg.getTransform(porttrans1);
            port2tg.getTransform(porttrans2);
            porttrans1.get(portvector1);
            porttrans2.get(portvector2);
            hosttrans1.mul(porttrans1);
            hosttrans2.mul(porttrans2);
            hosttrans1.get(linkvector1);
            hosttrans2.get(linkvector2);   
            
        }
        
        pipe3d pipe = new pipe3d();        
        pipe = (pipe3d) this.getChild(0);
        pipe.updatePipe(linkvector1,linkvector2,0.05f,texture_lib.getAppearance(3));
        
        
    }    
    
    
}
