/* Scanmap is a 3d Visualisation for Snort alerts 
*   
*   Copyright (C) 2003 Daniel Clark
*
*	This program is free software; you can redistribute it and/or 
*	modify it under the terms of the GNU General Public License as 
*	published by the Free Software Foundation; either version 2 of 
*	the License, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful, 
*	but WITHOUT ANY WARRANTY; without even the implied warranty of 
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License 
*	along with this program; if not, write to the Free Software 
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*	
*	Contact: Daniel Clark 
*	Email:	scanmap3d@sourceforge.net
*	
*
*
* netview.java 		// Main Viewing Panel
*
* Created on March 14, 2003, 12:28 PM
*/
package net.ossim.scanmap;


import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.geometry.Cone;
import com.sun.j3d.utils.geometry.Cone;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Text2D;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.picking.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.io.*;
import java.awt.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.timer.J3DTimer;
import java.sql.*;
import java.util.*;
import java.net.*;
   

public class netview extends javax.swing.JPanel {
            

    public SimpleUniverse u;
    public Canvas3D c;
    public PickCanvas pickCanvas;
    public net3dapp texture_lib;
    public static scanmap3d this_scanmap;
    public static TransformGroup objScale;
    public static Switch link_switch;
    public static Switch packet_switch;    
    public static net3dapp apps;    
    public static Vector links_vector;
    public static Vector selected_ports;
    public static Vector selected_hosts;
    public static net3d network_gateway,network_inside1,network_inside2;
    public static net3d network_inside3,network_inside4,network_outside;
    public static BranchGroup scene;
    public OrbitBehavior orbit;
    public boolean filter_switch=false;
    public static int net_num=6;
    
    public BranchGroup createSceneGraph() {
    
	// Create the root of the branch graph
	BranchGroup objRoot = new BranchGroup();
        objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        objRoot.setPickable(true);
        objScale = new TransformGroup();
        objScale.setPickable(true);                
        
        
        Transform3D testTrans = new Transform3D();
        // Assuming uniform size chars, set scale to fit string in view
        testTrans.setScale(0.1);
        objScale.setTransform(testTrans);
	objScale.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objScale.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        objScale.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
        objScale.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
        objScale.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        objScale.setCapability(TransformGroup.ALLOW_PICKABLE_READ);
        // Allow read & write
	TransformGroup objTrans = new TransformGroup();
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);        
	objRoot.addChild(objTrans);

	BoundingSphere bounds =
	    new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

        // Make the three networks
        TransformGroup inside_tg1 = new TransformGroup();
        TransformGroup inside_tg2 = new TransformGroup();
	TransformGroup inside_tg3 = new TransformGroup();
	TransformGroup inside_tg4 = new TransformGroup();	
        TransformGroup gateway_tg = new TransformGroup();        
        TransformGroup outside_tg = new TransformGroup();

        network_inside1 = new net3d(1,texture_lib,this_scanmap);
        network_inside2= new net3d(2,texture_lib,this_scanmap);
	network_inside3= new net3d(3,texture_lib,this_scanmap);
	network_inside4= new net3d(4,texture_lib,this_scanmap); 
        network_gateway = new net3d(0,texture_lib,this_scanmap);
	network_outside = new net3d(5,texture_lib,this_scanmap);
        
        setTransformGroupCapabilities(inside_tg1);
        setTransformGroupCapabilities(inside_tg2);
	setTransformGroupCapabilities(inside_tg3);
	setTransformGroupCapabilities(inside_tg4);
        setTransformGroupCapabilities(gateway_tg);
	setTransformGroupCapabilities(outside_tg);
        
        inside_tg1.addChild(network_inside1);
        inside_tg2.addChild(network_inside2);
	inside_tg3.addChild(network_inside3);
	inside_tg4.addChild(network_inside4);        
        gateway_tg.addChild(network_gateway);
        outside_tg.addChild(network_outside);

        link_switch = new Switch();
        link_switch.setCapability(Switch.ALLOW_CHILDREN_EXTEND);
        link_switch.setCapability(Switch.ALLOW_CHILDREN_READ);
        link_switch.setCapability(Switch.ALLOW_CHILDREN_WRITE);
        link_switch.setCapability(Switch.ALLOW_SWITCH_WRITE);
        link_switch.setCapability(Switch.ALLOW_SWITCH_READ);
        link_switch.setWhichChild(Switch.CHILD_ALL);        
        
        packet_switch = new Switch();
        packet_switch.setCapability(Switch.ALLOW_CHILDREN_EXTEND);
        packet_switch.setCapability(Switch.ALLOW_CHILDREN_READ);
        packet_switch.setCapability(Switch.ALLOW_CHILDREN_WRITE);
        packet_switch.setCapability(Switch.ALLOW_SWITCH_WRITE);
        packet_switch.setCapability(Switch.ALLOW_SWITCH_READ);
        packet_switch.setWhichChild(Switch.CHILD_ALL);
        
        objScale.addChild(inside_tg1);
        objScale.addChild(inside_tg2);
	objScale.addChild(inside_tg3);
	objScale.addChild(inside_tg4);
        objScale.addChild(gateway_tg);
	objScale.addChild(outside_tg);
        objScale.addChild(link_switch);
        objScale.addChild(packet_switch);
      
        TransformGroup firetg = new TransformGroup();
        Transform3D firetrans = new Transform3D();
        firetrans.set(new Vector3f(0.0f,-0.25f,0.0f));
        firetg.setTransform(firetrans);
        Appearance fireapp = new Appearance();
        fireapp.setColoringAttributes(new
	    ColoringAttributes(1.0f,0.0f,0.0f,0));
        fireapp.setTransparencyAttributes(new TransparencyAttributes(
            TransparencyAttributes.FASTEST,0.7f));
        Box firewall = new Box(100.0f,0.5f,10.0f,fireapp);
        firetg.setPickable(true);
        firetg.addChild(firewall);
        objScale.addChild(firetg);
        
        objRoot.addChild(objScale);  
                
        // Set up the background
        Color3f bgColor = new Color3f(0.0f, 0.0f, 0.0f);
        Background bgNode = new Background(bgColor);
        bgNode.setApplicationBounds(bounds);
        objRoot.addChild(bgNode);
        
        // Set up the ambient light
        Color3f ambientColor = new Color3f(0.1f, 0.1f, 0.1f);
        AmbientLight ambientLightNode = new AmbientLight(ambientColor);
        ambientLightNode.setInfluencingBounds(bounds);
        objRoot.addChild(ambientLightNode);
	
        // Set up the directional lights
        Color3f light1Color = new Color3f(1.0f, 1.0f, 1.0f);
        Vector3f light1Direction  = new Vector3f(1.0f, 1.0f, 1.0f);
        Color3f light2Color = new Color3f(1.0f, 1.0f, 0.9f);
        Vector3f light2Direction  = new Vector3f(-1.0f, -1.0f, -1.0f);

        
        DirectionalLight light1
            = new DirectionalLight(light1Color, light1Direction);
        light1.setInfluencingBounds(bounds);
        objRoot.addChild(light1);
          
        DirectionalLight light2
            = new DirectionalLight(light2Color, light2Direction);
        light2.setInfluencingBounds(bounds);
        objRoot.addChild(light2);
        
        objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        
        // Have Java 3D perform optimizations on this scene graph.
        objRoot.compile();               

	return objRoot;
     
    }
    
    public void setTransformGroupCapabilities(TransformGroup transin){
        transin.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
        transin.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
        transin.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        transin.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        transin.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        transin.setPickable(true);
    }
    
    public void processPacket(ip_packet inpacket) {      
        

        
        // Test for printing incoming packet details
        /*
        System.out.println ("incoming packet");
        System.out.println("src_ip "+inpacket.src_ip+ ":" +inpacket.src_port);
        System.out.println("dst_ip "+inpacket.dst_ip+ ":" +inpacket.dst_port);
        System.out.println("timestamp " + inpacket.timestamp);
        */
        boolean netchange = false;
        net3d srcnet = new net3d(texture_lib);
        net3d dstnet = new net3d(texture_lib);
        srcnet = (net3d) getNetwork(inpacket.src_ip);
        dstnet = (net3d) getNetwork(inpacket.dst_ip);
        int srctype = srcnet.type;
        int dsttype = dstnet.type;        
        
        Text2D text_text = new Text2D("test",new Color3f(1.0f,1.0f,1.0f),"Serif",100,Font.PLAIN);
        
        // Add the src host if it doesn't exist
        if (!srcnet.isHost(inpacket.src_ip)){
            srcnet.addHost((String) inpacket.src_ip,srctype);
            netchange = true;
        }
        
        // Add the dst host if it doesn't exist
        if (!dstnet.isHost(inpacket.dst_ip)){
            dstnet.addHost((String) inpacket.dst_ip,dsttype);
            netchange = true;
        }               
                        
        
        host3d srchost = new host3d(texture_lib);
        host3d dsthost = new host3d(texture_lib);        
        srchost = (host3d) srcnet.getHost(inpacket.src_ip);   
        dsthost = (host3d) dstnet.getHost(inpacket.dst_ip);
        
        // check that the source port exists
        if (!(srchost.isPort(inpacket.src_port))){
            srchost.addPort(inpacket.src_port,true);
            netchange = true;
        }        
        
        // check that the dest port exists               
        
        if (!(dsthost.isPort(inpacket.dst_port))){    
            dsthost.addPort(inpacket.dst_port,false);
            netchange = true;
        }         
        
        // Update packets and links
        if (netchange){
            
            int packet3d_num = scanmap3d.view3d.packet_switch.numChildren();
            for (int i=0;i< packet3d_num;i++) {
                BranchGroup tempbg = new BranchGroup();
		if (scanmap3d.view3d.packet_switch.numChildren()>i){
                	tempbg = (BranchGroup) scanmap3d.view3d.packet_switch.getChild(i);
                	animpacket3d temppacket3d = new animpacket3d(texture_lib);
                	temppacket3d = (animpacket3d) tempbg.getChild(0);
                	temppacket3d.updatePacket();
		}
            }
            
            for (int i=0; i< link_switch.numChildren();i++){
                netlink3d templink3d = new netlink3d(texture_lib);
                BranchGroup bgtemp = new BranchGroup();
                bgtemp = (BranchGroup) link_switch.getChild(i);
                templink3d = (netlink3d) bgtemp.getChild(0);
                templink3d.updateLink();
            }
            
        }
        
        
        // Draw the Packet
        BranchGroup newpacket = new BranchGroup();
        
        newpacket.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        newpacket.setCapability(BranchGroup.ALLOW_DETACH);        
                
        animpacket3d packetsphere = new animpacket3d(dsthost,srchost,
            inpacket,texture_lib);                  
        
        newpacket.addChild(packetsphere);
        packet_switch.addChild(newpacket);  
        // decide wether to show the packet or not
        
        if (scanmap3d.my_tool_window.byPort.isSelected()||scanmap3d.my_tool_window.byHost.isSelected()){
            port3d temp_port1 = new port3d(texture_lib);
            port3d temp_port2 = new port3d(texture_lib);
            temp_port1 = packetsphere.host1.getPort(packetsphere.port1);
            temp_port2 = packetsphere.host2.getPort(packetsphere.port2);
            BitSet Packet_Mask = packet_switch.getChildMask();                
            if((packetsphere.host1.selected||packetsphere.host2.selected)||
                (temp_port1.selected||temp_port2.selected)||
                (temp_port1.port==-1&&packetsphere.host1.selected)||
                (temp_port2.port==-1&&packetsphere.host2.selected)){

                Packet_Mask.set(packet_switch.numChildren());
            }
            else {
                Packet_Mask.clear(packet_switch.numChildren());
            }       
            packet_switch.setChildMask(Packet_Mask);
        }
        
        
        // Add a link if it doesn't exist already
        if (!isLink(inpacket)){
            links_vector.addElement(inpacket);
            BranchGroup bgtemp = new BranchGroup();  
            bgtemp.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
            bgtemp.setCapability(BranchGroup.ALLOW_DETACH);
            netlink3d newlink = new netlink3d(dsthost,srchost,inpacket,texture_lib);
            bgtemp.addChild(newlink);
            link_switch.addChild(bgtemp);
            // check if we should show the link
            if (scanmap3d.my_tool_window.byPort.isSelected()||scanmap3d.my_tool_window.byHost.isSelected()){
                port3d temp_port1 = new port3d(texture_lib);
                port3d temp_port2 = new port3d(texture_lib);
                temp_port1 = newlink.host1.getPort(newlink.port1);
                temp_port2 = newlink.host2.getPort(newlink.port2);
                BitSet Link_Mask = link_switch.getChildMask();  
                if((newlink.host1.selected||newlink.host2.selected)||
                    (temp_port1.selected||temp_port2.selected)||
                    (temp_port1.port==-1&&newlink.host1.selected)||
                    (temp_port2.port==-1&&newlink.host2.selected)){
                        
                    Link_Mask.set(link_switch.numChildren());
                }
                else {
                    Link_Mask.clear(link_switch.numChildren());
                }       
                link_switch.setChildMask(Link_Mask);
            } else {
                BitSet Link_Mask = link_switch.getChildMask();
                Link_Mask.set(link_switch.numChildren());
                link_switch.setChildMask(Link_Mask);
            }
        }
        
        
    }
    
    public boolean isLink(ip_packet inpacket){
        boolean is_link = false;        

        for (int i=0;i<links_vector.size();i++){
            ip_packet temppacket = new ip_packet();
            temppacket = (ip_packet) links_vector.elementAt(i);
            if (((temppacket.dst_ip.equals(inpacket.dst_ip)) &&
                 (temppacket.src_ip.equals(inpacket.src_ip)) &&
                 (temppacket.src_port == inpacket.src_port) &&
                 (temppacket.dst_port == inpacket.dst_port)) ||                                  
                 ((temppacket.dst_ip.equals(inpacket.src_ip)) &&
                 (temppacket.src_ip.equals(inpacket.dst_ip)) &&
                 (temppacket.src_port == inpacket.dst_port) &&                
                 (temppacket.dst_port == inpacket.src_port))) {
                    is_link = true;
                    return is_link;                                    
            }
        }
        return is_link;
    }
    
    public net3d getNetwork(String ip_in){

        if (ip_in==null){
            System.out.println("ip was null");
            return null;
        }
                
        if(ipMatches(ip_in,scanmap3d.gw1)
	    ||ipMatches(ip_in,scanmap3d.gw2)
	    ||ipMatches(ip_in,scanmap3d.gw3)
	    ||ipMatches(ip_in,scanmap3d.gw4)) {
            return this.network_gateway;
        }

        if (ipMatches(ip_in,scanmap3d.insidenet1)) {
            return this.network_inside1;
        } 
        if (ipMatches(ip_in,scanmap3d.insidenet2)) {
            return this.network_inside2;
        } 
        if (ipMatches(ip_in,scanmap3d.insidenet3)){
            return this.network_inside3;
        } 
        if (ipMatches(ip_in,scanmap3d.insidenet4)) {
            return this.network_inside4;
        }         

	// must be outside
	return this.network_outside;        
    }

    public boolean ipMatches(String ip_in, String test_ip_in){

	boolean answer=false;

	// Are we dealing with an IP or netmask?

	if (test_ip_in.indexOf('/')!=-1){
		// netmask
		int slash = test_ip_in.indexOf('/');
	        String test_ip = test_ip_in.substring(0,slash);
		String netmask = test_ip_in.substring(slash+1,test_ip_in.length());
	        InetAddress in_address=null;
		InetAddress test_address=null;        
	        try {
        	    in_address= InetAddress.getByName(ip_in);            
        	    test_address = InetAddress.getByName(test_ip);
		
        	}
        	catch (Exception e){
			System.out.println("Problem getting IP");
			System.out.println("in:"+test_ip+" mask "+ netmask);
		}
               
	        byte [] in_bytes = in_address.getAddress();
	        byte [] test_bytes = test_address.getAddress();		

		String bit_mask = "";		
		for (int i=0;i<Integer.parseInt(netmask);i++){
			bit_mask=bit_mask.concat("1");
		};
		for (int i=bit_mask.length();i<31;i++){
			bit_mask=bit_mask.concat("0");
		}
		
		String mask_1=bit_mask.substring(0,7);		
		String mask_2=bit_mask.substring(8,15);		
		String mask_3=bit_mask.substring(16,23);		
		String mask_4=bit_mask.substring(24,31);
		byte [] mask_bytes = { Byte.parseByte(mask_1,2),
					Byte.parseByte(mask_2,2),
					Byte.parseByte(mask_3,2),
					Byte.parseByte(mask_4,2)};

		
	        if ((mask_bytes[0]&in_bytes[0])==(mask_bytes[0]&test_bytes[0])&&
			(mask_bytes[1]&in_bytes[1])==(mask_bytes[1]&test_bytes[1])&&
			(mask_bytes[2]&in_bytes[2])==(mask_bytes[2]&test_bytes[2])&&
			(mask_bytes[3]&in_bytes[3])==(mask_bytes[3]&test_bytes[3])) {	          		  
       		     answer=true;
       		 }                 
	}
	else {
		// standard ip
		if (ip_in.equals(test_ip_in)){
			answer=true;
		}
	}
	return answer;
    }
    
    public net3d getNetwork(int in_net) {      
        switch (in_net) {
            
            case 1:
                return this.network_inside1;
                                
            case 2:
                return this.network_inside2;
                
            case 3:
                return this.network_inside3;
                
            case 4:
                return this.network_inside4;

	    case 0:
		return this.network_gateway;

	    case 5:
		return this.network_outside;
        }

        return new net3d(texture_lib);
    }
    
    public void play() {
        
        int packet3d_num = scanmap3d.view3d.packet_switch.numChildren();
        for (int i=0;i< packet3d_num;i++) {
            BranchGroup tempbg = new BranchGroup();
            tempbg = (BranchGroup) scanmap3d.view3d.packet_switch.getChild(i);
            animpacket3d temppacket = new animpacket3d(texture_lib);
            temppacket = (animpacket3d) tempbg.getChild(0);

            if (temppacket.animAlpha.isPaused()){
                temppacket.animAlpha.resume();
            }
        }        
    }
    public void pause() {
        
        int packet3d_num = scanmap3d.view3d.packet_switch.numChildren();
        for (int i=0;i< packet3d_num;i++) {
            BranchGroup tempbg = new BranchGroup();
            tempbg = (BranchGroup) scanmap3d.view3d.packet_switch.getChild(i);
            animpacket3d temppacket = new animpacket3d(texture_lib);
            temppacket = (animpacket3d) tempbg.getChild(0);

            if (!temppacket.animAlpha.isPaused()){
                temppacket.animAlpha.pause();
            }
        }         
    }
    
    public void byHostOn() {
        // turn the hosts on
        for (int i=0;i<net_num;i++){            
            net3d temp_net = new net3d(texture_lib);
            temp_net = getNetwork(i);
            temp_net.byHostOn();
        }
        
        // turn the links & packets on
        BitSet Packet_Mask = new BitSet();
        int packet3d_num = scanmap3d.view3d.packet_switch.numChildren();
        
        for (int i=0;i< packet3d_num;i++) {
            BranchGroup tempbg = new BranchGroup();
            tempbg = (BranchGroup) scanmap3d.view3d.packet_switch.getChild(i);
            animpacket3d temppacket3d = new animpacket3d(texture_lib);
            temppacket3d = (animpacket3d) tempbg.getChild(0);                
            
            if(temppacket3d.host1.selected||temppacket3d.host2.selected){
                Packet_Mask.set(i);
            }
            else {
                Packet_Mask.clear(i);
            }            
        }
        scanmap3d.view3d.packet_switch.setWhichChild(Switch.CHILD_MASK);
        scanmap3d.view3d.packet_switch.setChildMask(Packet_Mask);
        
        BitSet Link_Mask = new BitSet();
        for (int i=0; i< link_switch.numChildren();i++){
            netlink3d templink3d = new netlink3d(texture_lib);
            BranchGroup bgtemp = new BranchGroup();
            bgtemp = (BranchGroup) link_switch.getChild(i);
            templink3d = (netlink3d) bgtemp.getChild(0);
            if(templink3d.host1.selected||templink3d.host2.selected){
                Link_Mask.set(i);
            }
            else {
                Link_Mask.clear(i);
            }       
        }
        link_switch.setWhichChild(Switch.CHILD_MASK);
        link_switch.setChildMask(Link_Mask);                
    }
    
    public void byHostOff(){
        // turn the hosts off
        for (int i=0;i<net_num;i++){            
            net3d temp_net = new net3d(texture_lib);
            temp_net = getNetwork(i);
            temp_net.byHostOff();
        }        
        if (!scanmap3d.my_tool_window.byPort.isSelected()){
            scanmap3d.view3d.packet_switch.setWhichChild(Switch.CHILD_ALL);
            link_switch.setWhichChild(Switch.CHILD_ALL);        
        }
    }
    
    public void filterOn(){
        filter_switch=true;
    }
    public void filterOff(){
        filter_switch=false;
    }
    
    public void byPortOn(){
        // turn the links & packets on
        BitSet Packet_Mask = new BitSet();
        int packet3d_num = scanmap3d.view3d.packet_switch.numChildren();            
        for (int i=0;i< packet3d_num;i++) {
            BranchGroup tempbg = new BranchGroup();
            tempbg = (BranchGroup) scanmap3d.view3d.packet_switch.getChild(i);
            animpacket3d temppacket3d = new animpacket3d(texture_lib);
            temppacket3d = (animpacket3d) tempbg.getChild(0);            
            port3d temp_port1 = new port3d(texture_lib);
            port3d temp_port2 = new port3d(texture_lib);
            temp_port1 = temppacket3d.host1.getPort(temppacket3d.port1);
            temp_port2 = temppacket3d.host2.getPort(temppacket3d.port2);            
            boolean portSelected = false;
            
            for (int j=0;j<selected_ports.size();j++){
                String port_string = (String) selected_ports.elementAt(j);                
                int port_int = Integer.parseInt(port_string);
                if (temp_port1.port == port_int||
                    temp_port2.port == port_int){
                        portSelected = true;
                }
            }
                
            if(portSelected||
                ((temppacket3d.port1==-1)&&temppacket3d.host1.selected)
                ||((temppacket3d.port2==-1)&&temppacket3d.host2.selected)){
                Packet_Mask.set(i);
            }
            else {
                Packet_Mask.clear(i);
            }            
        }
        if (Packet_Mask!=null){
        scanmap3d.view3d.packet_switch.setWhichChild(Switch.CHILD_MASK);
        scanmap3d.view3d.packet_switch.setChildMask(Packet_Mask);
        }
            
        
        BitSet Link_Mask = new BitSet();
        for (int i=0; i< link_switch.numChildren();i++){
            netlink3d templink3d = new netlink3d(texture_lib);
            BranchGroup bgtemp = new BranchGroup();
            bgtemp = (BranchGroup) link_switch.getChild(i);
            templink3d = (netlink3d) bgtemp.getChild(0);
            port3d temp_port1 = new port3d(texture_lib);
            port3d temp_port2 = new port3d(texture_lib);
            temp_port1 = templink3d.host1.getPort(templink3d.port1);
            temp_port2 = templink3d.host2.getPort(templink3d.port2);
            
            boolean portSelected = false;
            
            for (int j=0;j<selected_ports.size();j++){
                String port_string = (String) selected_ports.elementAt(j);                                
                int port_int = Integer.parseInt(port_string);                
                if (temp_port1.port == port_int||
                    temp_port2.port == port_int){
                        portSelected = true;
                }
            }
            
            if(portSelected||
                ((templink3d.port1==-1)&&templink3d.host1.selected)
                ||((templink3d.port2==-1)&&templink3d.host2.selected)){
                Link_Mask.set(i);
            }
            else {
                Link_Mask.clear(i);
            }       
        }
        link_switch.setWhichChild(Switch.CHILD_MASK);
        link_switch.setChildMask(Link_Mask);            
    }
    
    public void byPortOff(){
        if (!scanmap3d.my_tool_window.byHost.isSelected()){
            scanmap3d.view3d.packet_switch.setWhichChild(Switch.CHILD_ALL);
            link_switch.setWhichChild(Switch.CHILD_ALL);   
        }
    }
    
    public void linkson(){
        link_switch.setWhichChild(Switch.CHILD_ALL);             
    }
    public void linksoff(){

        link_switch.setWhichChild(Switch.CHILD_NONE);
    }

    public void packetson(){
        packet_switch.setWhichChild(Switch.CHILD_ALL);
    }
    public void packetsoff(){
        packet_switch.setWhichChild(Switch.CHILD_NONE);
    }
    
    public void clearAll(){
        for (int i=0;i<net_num;i++){            
            net3d temp_net = new net3d(texture_lib);
            temp_net = (net3d) getNetwork(i);
            temp_net.host_switch.removeAllChildren();
        }        
        
        packet_switch.removeAllChildren();
        link_switch.removeAllChildren();
        links_vector.removeAllElements();
        selected_ports.removeAllElements();
        selected_hosts.removeAllElements();
        
    }
    
    
    private void netviewMouseClicked(java.awt.event.MouseEvent evt) {
        
        boolean transform_view=false;
        pickCanvas.setShapeLocation(evt);
        if (pickCanvas.pickAll()==null){
            return;
        }
        PickResult[] results = pickCanvas.pickAll();
        PickResult result=null;
        for (int j=0;j<results.length;j++){
            if (results[j].getSceneGraphPath().nodeCount()>0)
            {
                result = results[j];
            };
        }
        
         if ((evt.getModifiers() & MouseEvent.SHIFT_MASK)  == evt.SHIFT_MASK) {
            transform_view=true;
        }
        
        host3d temp_host = new host3d(texture_lib);
        if (result!=null){            
            if(result.getSceneGraphPath().nodeCount()>0){
                String identstring = (String) result.getSceneGraphPath().getNode(0).
                    getUserData();                                        
                    if (identstring!=null && !identstring.equals("ignore")) {
                        // add the port if it is a port
                        if ((!(identstring.indexOf(':')==-1))){
                            String hostident = identstring
                                .substring(0,identstring.indexOf(':'));
                            String port = identstring.substring(identstring.indexOf(':')+1,
                                identstring.length());
                            net3d temp_net = new net3d(texture_lib);
                            temp_net = (net3d) getNetwork(hostident);
                            temp_host= (host3d) temp_net.getHost(hostident);        
                            port3d temp_port = (port3d) temp_host.getPort(Integer.parseInt(port));
                            Switch temp_switch = new Switch();
                            TransformGroup temp_tg = new TransformGroup();
                            temp_tg = (TransformGroup) temp_port.getChild(0);        
                            temp_switch = (Switch) temp_tg.getChild(2);
                            // is the port selected
                            if (temp_port==null || temp_host ==null){
                                System.out.println("null host or port");
                                return;
                            }
                            if (!transform_view){
                                if (temp_port.selected) {
                                    temp_port.selected = false; 
                                    for (int i=0;i<selected_ports.size();i++){
                                        if (selected_ports.elementAt(i).equals(port)){
                                            selected_ports.removeElementAt(i);
                                            i--;
                                        }
                                    }
                                    temp_switch.setWhichChild(Switch.CHILD_NONE);
                                }
                                else {
                                    temp_port.selected = true;
                                    temp_switch.setWhichChild(Switch.CHILD_ALL);
                                    boolean exists = false;
                                    if (selected_ports.size()!=0){
                                        for (int i=0; i<selected_ports.size();i++){
                                            if (selected_ports.elementAt(i).equals(port)){
                                                exists=true;
                                            }
                                        }
                                    }
                                    if (!exists){
                                        selected_ports.addElement(port);
                                    }
                                }
                            }
                            else {
                                Transform3D hosttrans = new Transform3D();
                                temp_host.getTransform(hosttrans);
                                Vector3d hostvect = new Vector3d();
                                Point3d hostpoint = new Point3d();                               
                                hosttrans.get(hostvect);
                                hostvect.get(hostpoint);
                                hostpoint.scale(0.1);                                
                                orbit.setRotationCenter(hostpoint);
                            }                                                        
                        }
                        
                        else if (!(identstring.indexOf('#')==-1)){
                            String hostident = identstring
                                .substring(identstring.indexOf('#')+1,
                                    identstring.length()); 
                            net3d temp_net = new net3d(texture_lib);
                            temp_net = (net3d) getNetwork(hostident);
                            temp_host= (host3d) temp_net.getHost(hostident);
                            if (temp_host.details){
                                temp_host.detailsOff();
                            }
                            else {
                                host_stats this_stats = new host_stats();
                                this_scanmap.packetDatabase.getHostStats(temp_host,this_stats);                                
                                temp_host.detailsOn(this_stats);
                            }
                        }                                                   
                        else {                            
                            net3d temp_net = new net3d(texture_lib);
                            temp_net = (net3d) getNetwork(identstring);
                            temp_host= (host3d) temp_net.getHost(identstring);        
                            Switch temp_switch = new Switch();
                            TransformGroup temp_tg = new TransformGroup();
                            temp_tg = (TransformGroup) temp_host.getChild(0);        
                            temp_switch = (Switch) temp_tg.getChild(1);
                            // is the host selected
                            if (temp_net==null || temp_host ==null){
                                System.out.println("null host or net");
                                return;
                            }
                            if (!transform_view){
                                if (temp_host.selected) {                                
                                    temp_host.selected = false;
                                    temp_switch.setWhichChild(Switch.CHILD_NONE);
                                    for (int i=0;i<selected_hosts.size();i++){
                                        if (selected_hosts.elementAt(i).equals(identstring)){
                                            selected_hosts.removeElementAt(i);
                                            i--;
                                        }
                                    }
                                    for (int i=0; i<selected_ports.size();i++){
                                        if (selected_ports.elementAt(i).equals("-1")){
                                            selected_ports.removeElementAt(i);
                                            i--;
                                        }
                                    }
                                }
                                else {

                                    temp_host.selected = true;
                                    temp_switch.setWhichChild(Switch.CHILD_ALL);

                                    boolean exists = false;
                                    if (selected_hosts.size()>0){
                                        for (int i=0; i<selected_hosts.size();i++){
                                            if (selected_hosts.elementAt(i).equals(identstring)){
                                                exists=true;
                                            }
                                        }
                                    }
                                    if (!exists){
                                        selected_hosts.addElement(identstring);
                                    }
                                    boolean port_exists = false;
                                    for (int i=0; i< selected_ports.size();i++){
                                        if (selected_ports.elementAt(i).equals("-1")){
                                            port_exists= true;
                                        }
                                    }
                                    if (!port_exists){
                                        selected_ports.addElement("-1");
                                    }
                                }
                            }
                            else {
                                Transform3D hosttrans = new Transform3D();
                                temp_host.getTransform(hosttrans);
                                Vector3d hostvect = new Vector3d();
                                Point3d hostpoint = new Point3d();                               
                                hosttrans.get(hostvect);
                                hostvect.get(hostpoint);
                                hostpoint.scale(0.1);
                                orbit.setRotationCenter(hostpoint);
                            }
                        }
                    }
                            
            }                        
        }
        
        
    }    

    public netview(net3dapp in_textures,scanmap3d in_scanmap) {  
        
        this_scanmap=in_scanmap;        
        apps = new net3dapp();
        links_vector = new Vector();
        selected_hosts = new Vector();
        selected_ports = new Vector();
        texture_lib = in_textures;
        
	setLayout(new BorderLayout());

	c = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
	add("Center", c);
        
        // add mouse listener
        c.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                netviewMouseClicked(evt);
            }
        });
        
	// Create a simple scene and attach it to the virtual universe
	scene = createSceneGraph();
	u = new SimpleUniverse(c);
        u.setJ3DThreadPriority(Thread.MAX_PRIORITY-2);  
	// add mouse behaviors to the ViewingPlatform
	ViewingPlatform viewingPlatform = u.getViewingPlatform();
        viewingPlatform.setNominalViewingTransform();

	// add orbit behavior to the viewing platform
	orbit = new OrbitBehavior(c, OrbitBehavior.REVERSE_ALL);
	BoundingSphere bounds =
	    new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
	orbit.setSchedulingBounds(bounds);
	viewingPlatform.setViewPlatformBehavior(orbit);
	Transform3D t3d = new Transform3D();
	t3d.lookAt(new Point3d(20,20,20), new Point3d(0,0,0), 
		new Vector3d(0,0,1));
  	t3d.invert();
  	viewingPlatform.getViewPlatformTransform().setTransform(t3d);        
	u.addBranchGraph(scene);
        pickCanvas = new PickCanvas(c,scene);
        pickCanvas.setMode(PickCanvas.BOUNDS);
        pickCanvas.setTolerance(2.0f);
        
        
    }

}
