/* Scanmap is a 3d Visualisation for Snort alerts 
*   
*   Copyright (C) 2003 Daniel Clark
*
*	This program is free software; you can redistribute it and/or 
*	modify it under the terms of the GNU General Public License as 
*	published by the Free Software Foundation; either version 2 of 
*	the License, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful, 
*	but WITHOUT ANY WARRANTY; without even the implied warranty of 
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License 
*	along with this program; if not, write to the Free Software 
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*	
*	Contact: Daniel Clark 
*	Email:	scanmap3d@sourceforge.net
*	
*
*
* port3d.java // Main program file
*
* Created on March 14, 2003, 12:28 PM
*/

package net.ossim.scanmap;


import java.lang.Math.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Text2D;
import com.sun.j3d.utils.geometry.Cone;
import javax.media.j3d.*;
import java.util.*;
import java.awt.*;
import java.awt.image.*;


public class port3d extends javax.media.j3d.BranchGroup {
    

    public int port;
    public boolean selected;
    public String hostip;
    public net3dapp app;
    public boolean active;
    
    public port3d(net3dapp app_in) {        
        app = app_in;
    }
    public port3d(){
    }
    
    /** Creates a new instance of host3d */
    public port3d(int inport,int port_list_num,int port_list_length,String inhostip,net3dapp app_in,boolean src) {
        app = app_in;
        this.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        this.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        this.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        active=false;        
        hostip=inhostip;
        port=inport;             
        selected = false;         
        
        float port_offset = 0.0f;
                  

        Sphere portsphere = new Sphere(0.5f,Sphere.GENERATE_TEXTURE_COORDS,6,app.getAppearance(31));
        Sphere selectsphere = new Sphere(1.0f,Sphere.GENERATE_TEXTURE_COORDS,6,app.getAppearance(32));
        portsphere.setPickable(true);
        selectsphere.setPickable(false);
        portsphere.setUserData(hostip+":"+Integer.toString(port));
        Switch select_switch = new Switch();
        select_switch.addChild(selectsphere);
        select_switch.setCapability(Switch.ALLOW_SWITCH_WRITE);
        select_switch.setCapability(Switch.ALLOW_CHILDREN_READ);
        select_switch.setWhichChild(Switch.CHILD_NONE);
        select_switch.setPickable(false);

        TransformGroup portgroup = new TransformGroup();

        portgroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        portgroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        portgroup.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        portgroup.setCapability(TransformGroup.ALLOW_CHILDREN_READ);


        Transform3D porttransform = new Transform3D();            
		
        // New 2D Text          
        String portString = Integer.toString(inport);
        TransformGroup details_tg = new TransformGroup();
        Appearance text_appear = new Appearance();
        Dimension textSize = new Dimension(64,32);
        BufferedImage text_image = new BufferedImage(textSize.width,textSize.height,BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = (Graphics2D) text_image.getGraphics();
        g.setFont(new Font("Arial",Font.PLAIN,10));
		if (src){
			g.setColor(Color.red);
		}
		else {
			g.setColor(Color.blue);
		}
    	    g.fillRect(0,0,128,64);
		if (src){
			g.setColor(Color.blue);
		}
		else {
			g.setColor(Color.red);
		}
        g.drawString(portString,20,25);
        g.dispose();
        Texture2D texture=new
            Texture2D(Texture2D.BASE_LEVEL,Texture2D.RGBA,textSize.width, 
                textSize.height);
        texture.setImage(0, new ImageComponent2D(ImageComponent2D.FORMAT_RGBA,text_image));
        text_appear.setTexture(texture);
        texture.setBoundaryModeS(Texture2D.WRAP);
        texture.setBoundaryModeT(Texture2D.WRAP);

        PolygonAttributes polyAttrib = new PolygonAttributes(
            PolygonAttributes.POLYGON_FILL, 
            PolygonAttributes.CULL_BACK,0.0f);
        text_appear.setPolygonAttributes(polyAttrib);
        text_appear.setTransparencyAttributes(new TransparencyAttributes(
            TransparencyAttributes.NICEST,0.5f));
        int texture_mode = TextureAttributes.REPLACE;
        Color4f texture_color = new Color4f(0.0f,0.0f,0.0f,0.0f);
        
        text_appear.setTextureAttributes( new TextureAttributes(
            texture_mode, new Transform3D(),texture_color,0));  
		
        Box portbox = new Box(1.0f,1.0f,0.5f,Box.GENERATE_TEXTURE_COORDS,app.getAppearance(30));
        portbox.setPickable(true);
        portbox.setUserData(hostip+":"+Integer.toString(port));
        
        Transform3D topTrans = new Transform3D();
        topTrans.rotZ(Math.PI);
        Shape3D topshape = new Shape3D();
        topshape = portbox.getShape(Box.TOP);
        Appearance topAppear = (Appearance) text_appear.cloneNodeComponent(true);
        topAppear.setTextureAttributes(new TextureAttributes(texture_mode, topTrans,texture_color,0));        
        topshape.setAppearance(topAppear);
        
        Transform3D leftTrans = new Transform3D();
        leftTrans.rotZ(Math.PI/2);
        Shape3D leftshape = new Shape3D();
        leftshape = portbox.getShape(Box.LEFT);
        Appearance leftAppear = (Appearance) text_appear.cloneNodeComponent(true);
        leftAppear.setTextureAttributes(new TextureAttributes(texture_mode, leftTrans,texture_color,0));        
        leftshape.setAppearance(leftAppear);
        
        Transform3D rightTrans = new Transform3D();
        rightTrans.rotZ(-Math.PI/2);
        Shape3D rightshape = new Shape3D();
        rightshape = portbox.getShape(Box.RIGHT);
        Appearance rightAppear = (Appearance) text_appear.cloneNodeComponent(true);
        rightAppear.setTextureAttributes(new TextureAttributes(texture_mode, rightTrans,texture_color,0));        
        rightshape.setAppearance(rightAppear);        

        portbox.getShape(Box.BOTTOM).setAppearance(text_appear);        
        
        portgroup.setTransform(porttransform);
        portgroup.addChild(portsphere);
        portgroup.addChild(portbox);
        portgroup.addChild(select_switch);
        this.addChild(portgroup);

    
        

        
    }
    
}
