package net.ossim.scanmap;

import java.net.URL;
import java.io.InputStream;

import net.ossim.scanmap.dao.*;

import java.awt.BorderLayout;
import java.util.*;
import java.io.*;
import java.net.*;
import net.ossim.scanmap.dao.*;


/* Scanmap is a 3d Visualisation for Snort alerts
 *
 *   Copyright (C) 2003 Daniel Clark
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation; either version 2 of
 *	the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *	Contact: Daniel Clark
 *	Email:	scanmap3d@sourceforge.net
 *
 *
 *
 * scanmap3d.java // Main program file
 *
 * Created on March 14, 2003, 12:28 PM
 */



public class scanmap3d extends javax.swing.JFrame {

    static String sql_url;	// the URL used to access the mysql database
    static String sql_name;	// the name of the mysql database
    static String sql_login;
    static String sql_passwd;
    static String insidenet1,insidenet2,insidenet3,insidenet4; // the class C mask for inside networks
    static String gw1,gw2,gw3,gw4; // Gateway machines

    /* Url de donde sacamos el fichero para leerlo */
    private String textFileDataUrl;
    /* Flag que indica si la fuenta de datos es la BD */
    private boolean isMysqlDAO = false;

    public net3dapp textures;
    /* dao DE ACCESO A DATOS */
    public static ScanMapDAO packetDatabase;

    public static  Properties properties;

    public Vector packet_vector;
    public static DatabaseFilter dbfilter;
    public static tools_window my_tool_window;
    public static netview view3d;
    public static long starttime;

    // some control variables

    boolean isrunning=false;
    boolean donext=false;
    boolean dnslookup=false;
    public boolean filterswitch=false;

    static int interval=100;
    static int interval_max=150;
    static int delay=1000;
    static int speed=5000;
    public int packet_num=1;
    public int packet_count=0;

    private javax.swing.JLabel titleLabel;
    private javax.swing.JPanel titlePanel;
    private javax.swing.JLabel autherLabel;
    private javax.swing.JPanel viewPanel;

    /** Creates new form scanmap3d */
    public scanmap3d(String dataUrl,String textFileDataUrl) {
        textures = new net3dapp();
        readSettings(dataUrl);
        this.textFileDataUrl =  textFileDataUrl;
        initComponents();
        init3Dmap();
        this.show();
        scanmap3d.updateNetwork this_net = new scanmap3d.updateNetwork();
        scanmap3d.cleanupThread this_clean = new scanmap3d.cleanupThread();
        this_net.start();
        this_clean.start();
    }


    class cleanupThread extends Thread {
        public cleanupThread(){}
        public void run(){
            while(true){
                try {this.sleep(interval*10);} catch(Exception e){}
                // clean up old packets
                int packet3d_num = view3d.packet_switch.numChildren();
                for (int i=0;i< (packet3d_num);i++) {

                    javax.media.j3d.BranchGroup tempbg = new javax.media.j3d.BranchGroup();
                    if (view3d.packet_switch.numChildren()>i) {
                        tempbg = (javax.media.j3d.BranchGroup) view3d.packet_switch.getChild(i);
                        animpacket3d temppacket = new animpacket3d(textures);
                        temppacket = (animpacket3d) tempbg.getChild(0);

                        if (temppacket.animAlpha.finished()){
							if (view3d.packet_switch.numChildren()>=i){
	                            view3d.packet_switch.removeChild(i);
    	                        i=0;
							}
                        }
                    }
                    else {
                        break;
                    }
                }
                System.gc();
            }
        }

    }

    class updateNetwork extends Thread {

        int packet_pointer=0;

        public void run(){
            int counter = 0;
            isrunning = false;
            packet_num=0;
            starttime = com.sun.j3d.utils.timer.J3DTimer.getValue();
            java.sql.Timestamp newtime = new java.sql.Timestamp(0);
            packet_count=packetDatabase.packetcount(packet_count);
            packet_vector = new Vector();
            while (true){

                try {this.sleep(interval*10);}
		catch(Exception e){}
                newtime.setTime(com.sun.j3d.utils.timer.J3DTimer.getValue()/1000000);
                while(my_tool_window==null){};
                my_tool_window.worldTime.setText(newtime.toString());
                if (isrunning){
                    packet_count=packetDatabase.packetcount(packet_count);
                }

                // Read the packets into a vector

                if (packet_vector.size()!=(packet_count)&&isrunning){
                    //System.out.println("Adding Packets");
                    packetDatabase.addPackets(packet_vector,packet_vector.size(),packet_count);
                }
                // Step through the packets

                if ((isrunning&&(!((packet_num)>=packet_count-1)))||
                (donext)){

                    ip_packet newpacket = (ip_packet) packet_vector.elementAt(packet_num);

	            if (newpacket.timestamp!=null){
                        my_tool_window.setPacketTime(newpacket.timestamp.toString());
	            }
	            else {
                        System.out.println("no timestamp");
	            }

	            if (newpacket!=null&&newpacket.src_ip!=null
                        &&newpacket.dst_ip!=null) {
                        view3d.processPacket(newpacket);
	            }
	            else {
                        System.out.println( "packet was null");
	            }
	            if (packet_num!=(packet_count)){
                        packet_num++;
                    }

	            String packet_text = Integer.toString(packet_num+1);
	            packet_text = packet_text.concat(" of ");
	            packet_text = packet_text.concat(Integer.toString(packet_count));
	            my_tool_window.packetNumber.setText( packet_text);


                    if (donext){
                        donext=false;
                    }

                }
                System.gc();
            counter++;
            }
        }
    }


    /* Leemos las propiedades del fichero de configuracion */
    public void readSettings(String dataUrl){

        String in_string;
        java.util.Vector string_vect = new java.util.Vector();
        java.io.BufferedReader file_reader = null;
        try {
	    URL url = new URL(dataUrl);
	    InputStream in = url.openStream();

            /* Cargamos los datos */
            properties = new Properties();
            properties.load(in);

            String dbname = (String) properties.get("dbname");
            sql_login=(String) properties.get("username");
            sql_passwd=(String) properties.get("password");
            String host = (String) properties.get("host");
            /* Miramos si estamos accediendo a los datos sin fichero */
            if (
                dbname != null && !"".equals(dbname) &&
                sql_login != null && !"".equals(sql_login) &&
                host != null && !"".equals(host)){
              isMysqlDAO = true;
            }
            sql_url="jdbc:mysql://"+host+"/"+dbname;
            insidenet1= (String) properties.get("inside1");
            insidenet2= (String) properties.get("inside2");
            insidenet3= (String) properties.get("inside3");
            insidenet4= (String) properties.get("inside4");
            gw1 = (String) properties.get("gateway1");
            gw2 = (String) properties.get("gateway2");
            gw3 = (String) properties.get("gateway3");
            gw4 = (String) properties.get("gateway4");

        } catch (java.net.MalformedURLException e)  {
	    System.out.println(e);
	} catch (java.io.IOException e){
            System.out.println("Can't find config file \"scanmap3d.conf\"");
        }

    }


    public void init3Dmap()  {
            try {
              /* Obtenemos nuestro acceso a la BD dependiendo de los datos del fcihero de conf
                 para tirar del fcihero o tirar de la BD */
              if (!isMysqlDAO){
                packetDatabase = ScanMapDAOFactory.getTextFileDAO(textFileDataUrl, this);
              }else {
                packetDatabase = ScanMapDAOFactory.getMysqlDAO(sql_url,sql_login,sql_passwd,this);
              }
              dbfilter = new DatabaseFilter();
              view3d = new netview(textures, this);
              getContentPane().add(view3d);
            }catch (Exception ex) {
              System.out.println("Error al obtener la fuente de los datos segn configuracion.");
            }
    }


    private void initComponents() {
        titlePanel = new javax.swing.JPanel();
        titleLabel = new javax.swing.JLabel();
        autherLabel = new javax.swing.JLabel();
        viewPanel = new javax.swing.JPanel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        titlePanel.setLayout(new BorderLayout());

        titlePanel.setBackground(new java.awt.Color(0, 0, 153));
        titleLabel.setFont(new java.awt.Font("Dialog", 3, 18));
        titleLabel.setForeground(new java.awt.Color(255, 255, 255));
        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        titleLabel.setText("Scan Map 3D 2.0");
        titlePanel.add(titleLabel, BorderLayout.CENTER);

        autherLabel.setFont(new java.awt.Font("Dialog", 0, 10));
        autherLabel.setForeground(new java.awt.Color(255, 255, 255));
        autherLabel.setText("by Daniel Clark 2004");
        titlePanel.add(autherLabel, BorderLayout.EAST);

        getContentPane().add(titlePanel, BorderLayout.NORTH);

        viewPanel.setBackground(new java.awt.Color(153, 255, 255));
        viewPanel.setMinimumSize(new java.awt.Dimension(800, 400));
        viewPanel.setPreferredSize(new java.awt.Dimension(800, 400));


        getContentPane().add(viewPanel, BorderLayout.CENTER);

        pack();
    }

    /** Exit the Application */
    public void exitForm(java.awt.event.WindowEvent evt){
      /* Cerramos las ventanas */
      this.isrunning = false;
      my_tool_window.resetData();
      my_tool_window.scanmap_link.view3d.clearAll();
      this.hide();
      my_tool_window.hide();
    }

    public boolean isIsMysqlDAO() {
      return isMysqlDAO;
    }



    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {

    System.out.println("hola 1");
        scanmap3d this_scanmap = new scanmap3d("http://192.168.4.151:8500/ossim/scanmap3d.conf","http://192.168.4.151:8500/ossim/data.txt");
    System.out.println("hola 2");
        this_scanmap.setLocation(0,0);
    System.out.println("hola 3");
        this_scanmap.show();
    System.out.println("hola 4");
        my_tool_window = new tools_window(this_scanmap);
    System.out.println("hola 5");
        my_tool_window.setLocation(0,450);
    System.out.println("hola 6");
        my_tool_window.show();
        /* Hace que arranque automaticamente */
    System.out.println("hola 7");
//        this_scanmap.view3d.play();
    System.out.println("hola 8");
//        this_scanmap.isrunning=true;
    }

    /**
     * @param args the command line arguments
     */
    public static void main1(String args[]) {

        scanmap3d this_scanmap = new scanmap3d("http://192.168.4.151:8500/ossim/scanmap3d.conf","http://192.168.4.151:8500/ossim/data.txt");
        this_scanmap.setLocation(0,0);
        this_scanmap.show();
        my_tool_window = new tools_window(this_scanmap);
        my_tool_window.setLocation(0,450);
        my_tool_window.show();
        /* Hace que arranque automaticamente */
        this_scanmap.view3d.play();
        this_scanmap.isrunning=true;
    }




}
