/* Scanmap is a 3d Visualisation for Snort alerts
 *
 *   Copyright (C) 2003 Daniel Clark
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation; either version 2 of
 *	the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *	Contact: Daniel Clark
 *	Email:	scanmap3d@sourceforge.net
 *
 *
 *
 * tools_window.java // Tools Window
 *
 * Created on 1 August 2002, 08:37
 */

package net.ossim.scanmap;


public class tools_window extends javax.swing.JFrame {

    scanmap3d scanmap_link;

    /** Creates new form tool_windows */
    public tools_window(scanmap3d in_link) {
        this.scanmap_link = in_link;
        initComponents();
        intervalSlider.setValue(scanmap_link.interval);
        intervalValue.setText(Integer.toString(scanmap_link.interval));
        speedSlider.setValue(scanmap_link.speed);
        speedValue.setText(Integer.toString(scanmap_link.speed));
        delaySlider.setValue(scanmap_link.delay);
        delayValue.setText(Integer.toString(scanmap_link.delay));
    }

    public void setWorldTime(String in_time){
        worldTime.setText(in_time);
    }

    public void setPacketTime(String in_time)
    {
        packetTime.setText(in_time);
    }

    private void initComponents() {
        controlPanel = new javax.swing.JPanel();
        countPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        packetNumber = new javax.swing.JTextPane();
        timePanel = new javax.swing.JPanel();
        packetTimePanel = new javax.swing.JPanel();
        packetTimeLabel = new javax.swing.JLabel();
        packetTime = new javax.swing.JTextArea();
        worldTimePanel = new javax.swing.JPanel();
        worldTimeLabel = new javax.swing.JLabel();
        worldTime = new javax.swing.JTextArea();
        sliderPanel = new javax.swing.JPanel();
        delayPanel = new javax.swing.JPanel();
        delayLabel = new javax.swing.JLabel();
        delaySlider = new javax.swing.JSlider();
        delayValue = new javax.swing.JLabel();
        speedPanel = new javax.swing.JPanel();
        speedLabel = new javax.swing.JLabel();
        speedSlider = new javax.swing.JSlider();
        speedValue = new javax.swing.JLabel();
        intervalPanel = new javax.swing.JPanel();
        intervalLabel = new javax.swing.JLabel();
        intervalSlider = new javax.swing.JSlider();
        intervalValue = new javax.swing.JLabel();
        switchPanel = new javax.swing.JPanel();
        packetsButton = new javax.swing.JCheckBox();
        linksButton = new javax.swing.JCheckBox();
        byHost = new javax.swing.JCheckBox();
        byPort = new javax.swing.JCheckBox();
        filter = new javax.swing.JCheckBox();
        dnslookup = new javax.swing.JCheckBox();
        buttonPanel = new javax.swing.JPanel();
        reverseButton = new javax.swing.JButton();
        playButton = new javax.swing.JButton();
        forwardButton = new javax.swing.JButton();
        stopButton = new javax.swing.JButton();
        pauseButton = new javax.swing.JToggleButton();
        resetButton = new javax.swing.JButton();
        filterButton = new javax.swing.JButton();
        clearButton1 = new javax.swing.JButton();
        quitButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.FlowLayout());

        setTitle("SCANMAP TOOLS WINDOW");
        setName("tool_window");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        controlPanel.setBackground(new java.awt.Color(0, 0, 153));
        controlPanel.setMinimumSize(new java.awt.Dimension(800, 170));
        controlPanel.setPreferredSize(new java.awt.Dimension(800, 170));
        countPanel.setBackground(new java.awt.Color(0, 0, 153));
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("Count:");
        countPanel.add(jLabel3);

        packetNumber.setBackground(new java.awt.Color(0, 0, 153));
        packetNumber.setEditable(false);
        packetNumber.setForeground(new java.awt.Color(255, 255, 255));
        packetNumber.setText("0");
        packetNumber.setMargin(new java.awt.Insets(0, 0, 0, 0));
        packetNumber.setMinimumSize(new java.awt.Dimension(150, 22));
        packetNumber.setPreferredSize(new java.awt.Dimension(150, 16));
        packetNumber.setAutoscrolls(false);
        countPanel.add(packetNumber);

        controlPanel.add(countPanel);

        timePanel.setLayout(new java.awt.BorderLayout());

        timePanel.setBackground(new java.awt.Color(0, 0, 153));
        packetTimePanel.setBackground(new java.awt.Color(0, 0, 153));
        packetTimeLabel.setForeground(new java.awt.Color(255, 255, 255));
        packetTimeLabel.setText("packet time:");
        packetTimePanel.add(packetTimeLabel);

        packetTime.setEditable(false);
        packetTime.setPreferredSize(new java.awt.Dimension(170, 16));
        packetTimePanel.add(packetTime);

        timePanel.add(packetTimePanel, java.awt.BorderLayout.CENTER);

        worldTimePanel.setBackground(new java.awt.Color(0, 0, 153));
        worldTimeLabel.setForeground(new java.awt.Color(255, 255, 255));
        worldTimeLabel.setText("world time:");
        worldTimePanel.add(worldTimeLabel);

        worldTime.setEditable(false);
        worldTime.setMinimumSize(new java.awt.Dimension(150, 16));
        worldTime.setPreferredSize(new java.awt.Dimension(170, 16));
        worldTimePanel.add(worldTime);

        timePanel.add(worldTimePanel, java.awt.BorderLayout.NORTH);

        controlPanel.add(timePanel);

        sliderPanel.setLayout(new java.awt.BorderLayout());

        sliderPanel.setBackground(new java.awt.Color(0, 0, 153));
        sliderPanel.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        sliderPanel.setMinimumSize(new java.awt.Dimension(300, 82));
        sliderPanel.setPreferredSize(new java.awt.Dimension(300, 82));
        delayPanel.setBackground(new java.awt.Color(0, 0, 153));
        delayLabel.setBackground(new java.awt.Color(0, 0, 153));
        delayLabel.setForeground(new java.awt.Color(255, 255, 255));
        delayLabel.setText("packet delay:");
        delayPanel.add(delayLabel);

        delaySlider.setBackground(new java.awt.Color(0, 0, 153));
        delaySlider.setMajorTickSpacing(100);
        delaySlider.setMaximum(5000);
        delaySlider.setMinorTickSpacing(50);
        delaySlider.setValue(0);
        delaySlider.setPreferredSize(new java.awt.Dimension(100, 16));
        delaySlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                delaySliderMouseReleased(evt);
            }
        });

        delaySlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                delaySliderMouseDragged(evt);
            }
        });

        delayPanel.add(delaySlider);

        delayValue.setBackground(new java.awt.Color(0, 0, 153));
        delayValue.setForeground(new java.awt.Color(255, 255, 255));
        delayValue.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        delayValue.setText(Integer.toString(delaySlider.getValue()));
        delayValue.setPreferredSize(new java.awt.Dimension(50, 16));
        delayValue.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        delayPanel.add(delayValue);

        sliderPanel.add(delayPanel, java.awt.BorderLayout.CENTER);

        speedPanel.setBackground(new java.awt.Color(0, 0, 153));
        speedLabel.setBackground(new java.awt.Color(0, 0, 153));
        speedLabel.setForeground(new java.awt.Color(255, 255, 255));
        speedLabel.setText("packet speed:");
        speedPanel.add(speedLabel);

        speedSlider.setBackground(new java.awt.Color(0, 0, 153));
        speedSlider.setMajorTickSpacing(100);
        speedSlider.setMaximum(5000);
        speedSlider.setMinorTickSpacing(50);
        speedSlider.setValue(0);
        speedSlider.setPreferredSize(new java.awt.Dimension(100, 16));
        speedSlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                speedSliderMouseReleased(evt);
            }
        });

        speedSlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                speedSliderMouseDragged(evt);
            }
        });

        speedPanel.add(speedSlider);

        speedValue.setBackground(new java.awt.Color(0, 0, 153));
        speedValue.setForeground(new java.awt.Color(255, 255, 255));
        speedValue.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        speedValue.setText(Integer.toString(speedSlider.getValue()));
        speedValue.setPreferredSize(new java.awt.Dimension(50, 16));
        speedValue.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        speedPanel.add(speedValue);

        sliderPanel.add(speedPanel, java.awt.BorderLayout.NORTH);

        intervalPanel.setBackground(new java.awt.Color(0, 0, 153));
        intervalLabel.setBackground(new java.awt.Color(0, 0, 153));
        intervalLabel.setForeground(new java.awt.Color(255, 255, 255));
        intervalLabel.setText("packet interval");
        intervalPanel.add(intervalLabel);

        intervalSlider.setBackground(new java.awt.Color(0, 0, 153));
        intervalSlider.setMajorTickSpacing(100);
        intervalSlider.setMaximum(scanmap_link.interval_max);
        intervalSlider.setMinorTickSpacing(50);
        intervalSlider.setValue(scanmap_link.interval);
        intervalSlider.setPreferredSize(new java.awt.Dimension(100, 16));
        intervalSlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                intervalSliderMouseReleased(evt);
            }
        });

        intervalSlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                intervalSliderMouseDragged(evt);
            }
        });

        intervalPanel.add(intervalSlider);

        intervalValue.setBackground(new java.awt.Color(0, 0, 153));
        intervalValue.setForeground(new java.awt.Color(255, 255, 255));
        intervalValue.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        intervalValue.setText(Integer.toString(scanmap_link.interval));
        intervalValue.setPreferredSize(new java.awt.Dimension(50, 16));
        intervalValue.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        intervalPanel.add(intervalValue);

        sliderPanel.add(intervalPanel, java.awt.BorderLayout.SOUTH);

        controlPanel.add(sliderPanel);

        switchPanel.setBackground(new java.awt.Color(0, 0, 153));
        packetsButton.setBackground(new java.awt.Color(0, 0, 153));
        packetsButton.setForeground(new java.awt.Color(255, 255, 255));
        packetsButton.setSelected(true);
        packetsButton.setText("Packets");
        packetsButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                packetsButtonItemStateChanged(evt);
            }
        });

        switchPanel.add(packetsButton);

        linksButton.setBackground(new java.awt.Color(0, 0, 153));
        linksButton.setForeground(new java.awt.Color(255, 255, 255));
        linksButton.setSelected(true);
        linksButton.setText("Links");
        linksButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                linksButtonItemStateChanged(evt);
            }
        });

        switchPanel.add(linksButton);

        byHost.setBackground(new java.awt.Color(0, 0, 153));
        byHost.setForeground(new java.awt.Color(255, 255, 255));
        byHost.setText("byHost");
        byHost.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                byHostItemStateChanged(evt);
            }
        });

        switchPanel.add(byHost);

        byPort.setBackground(new java.awt.Color(0, 0, 153));
        byPort.setForeground(new java.awt.Color(255, 255, 255));
        byPort.setText("byPort");
        byPort.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                byPortItemStateChanged(evt);
            }
        });

        switchPanel.add(byPort);

        filter.setBackground(new java.awt.Color(0, 0, 153));
        filter.setForeground(new java.awt.Color(255, 255, 255));
        filter.setText("filtering");
        filter.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                filterItemStateChanged(evt);
            }
        });


        switchPanel.add(filter);



        dnslookup.setBackground(new java.awt.Color(0, 0, 153));
        dnslookup.setForeground(new java.awt.Color(255, 255, 255));
        dnslookup.setText("dnslookup");
        dnslookup.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                dnslookupItemStateChanged(evt);
            }
        });

        switchPanel.add(dnslookup);

        controlPanel.add(switchPanel);

        buttonPanel.setBackground(new java.awt.Color(0, 0, 153));
        reverseButton.setText("previous");
        reverseButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        reverseButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                reverseButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(reverseButton);

        playButton.setText("play");
        playButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        playButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                playButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(playButton);

        forwardButton.setText("next");
        forwardButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        forwardButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                forwardButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(forwardButton);

        stopButton.setText("Stop");
        stopButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        stopButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                stopButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(stopButton);

        pauseButton.setText("Pause");
        pauseButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        pauseButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                pauseButtonItemStateChanged(evt);
            }
        });

        pauseButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                pauseButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(pauseButton);

        resetButton.setText("Reset");
        resetButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        resetButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                resetButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(resetButton);

        filterButton.setText("Filter");
        filterButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        filterButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                filterButtonMouseClicked(evt);
            }

        });

        buttonPanel.add(filterButton);
        /* Lo deshabilitamos si venimos leyendo por fichero */
        if (!scanmap_link.isIsMysqlDAO()){
          filterButton.setEnabled(false);
        }

        clearButton1.setText("Clear All");
        clearButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        clearButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                clearButton1MouseClicked(evt);
            }
        });

        buttonPanel.add(clearButton1);

        quitButton.setText("Quit");
        quitButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        quitButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                quitButtonMouseClicked(evt);
            }
        });

        buttonPanel.add(quitButton);

        controlPanel.add(buttonPanel);

        getContentPane().add(controlPanel);

        pack();
    }

    private void dnslookupItemStateChanged(java.awt.event.ItemEvent evt) {
       if (scanmap_link.dnslookup){
           scanmap_link.dnslookup=false;
       } else {
           scanmap_link.dnslookup=true;
       }
    }

    private void resetButtonMouseClicked(java.awt.event.MouseEvent evt) {
      resetData();
    }

    public void resetData(){
      scanmap_link.isrunning=false;
      scanmap_link.packet_num=0;
      scanmap_link.packet_vector.removeAllElements();
      String packet_text = Integer.toString(scanmap_link.packet_num+1);
      packet_text = packet_text.concat(" of ");
      packet_text = packet_text.concat(Integer.toString(scanmap_link.packet_count));
      packetNumber.setText( packet_text);
    }

    private void pauseButtonItemStateChanged(java.awt.event.ItemEvent evt) {
        // Pause the 3D world
        if (pauseButton.isSelected()) {
            scanmap_link.isrunning=false;
            scanmap_link.view3d.pause();
        }
        else {
            scanmap_link.view3d.play();
        }
    }

    private void clearButton1MouseClicked(java.awt.event.MouseEvent evt) {
        scanmap_link.view3d.clearAll();
    }

    private void packetsButtonItemStateChanged(java.awt.event.ItemEvent evt) {
        if (!packetsButton.isSelected()){
            scanmap_link.view3d.packetsoff();
        }

        if (packetsButton.isSelected()){
            scanmap_link.view3d.packetson();
        }
    }

    private void linksButtonItemStateChanged(java.awt.event.ItemEvent evt) {
        if (!linksButton.isSelected()){
            scanmap_link.view3d.linksoff();
        }

        if (linksButton.isSelected()){
            scanmap_link.view3d.linkson();
        }
    }

    private void byHostItemStateChanged(java.awt.event.ItemEvent evt) {
        if (!byHost.isSelected()){
            scanmap_link.view3d.byHostOff();
        }
        if (byHost.isSelected()){
            scanmap_link.view3d.byHostOn();
        }
    }

    private void byPortItemStateChanged(java.awt.event.ItemEvent evt) {
        if (!byPort.isSelected()){
            scanmap_link.view3d.byPortOff();
        }
        if (byPort.isSelected()){
            scanmap_link.view3d.byPortOn();
        }
    }

    private void filterItemStateChanged(java.awt.event.ItemEvent evt) {
        if (filter.isSelected()){
            scanmap_link.filterswitch=true;
	    scanmap_link.packet_num=0;
            scanmap_link.packet_count=scanmap_link.packetDatabase.packetcount(0);
            scanmap_link.packet_vector.removeAllElements();

        }
        if (!filter.isSelected()){
            scanmap_link.filterswitch=false;
	    scanmap_link.packet_num=0;
            scanmap_link.packet_count=scanmap_link.packetDatabase.packetcount(0);
            scanmap_link.packet_vector.removeAllElements();

        }
        String packet_text = Integer.toString(scanmap_link.packet_num+1);
        packet_text = packet_text.concat(" of ");
        packet_text = packet_text.concat(Integer.toString(scanmap_link.packet_count));
        packetNumber.setText( packet_text);
    }
    private void quitButtonMouseClicked(java.awt.event.MouseEvent evt) {
        System.exit(0);
    }

    private void filterButtonMouseClicked(java.awt.event.MouseEvent evt) {
        filter_window newfilter = new filter_window();
        newfilter.show();
    }

    private void pauseButtonMouseClicked(java.awt.event.MouseEvent evt) {
        // Add your handling code here:
    }

    private void speedSliderMouseReleased(java.awt.event.MouseEvent evt) {
        scanmap_link.speed = 5000 - speedSlider.getValue();
    }

    private void intervalSliderMouseReleased(java.awt.event.MouseEvent evt) {
        scanmap_link.interval = intervalSlider.getValue();
    }

    private void delaySliderMouseReleased(java.awt.event.MouseEvent evt) {
        scanmap_link.delay = delaySlider.getValue();
    }

    private void intervalSliderMouseDragged(java.awt.event.MouseEvent evt) {
        intervalValue.setText(Integer.toString(intervalSlider.getValue()));
    }

    private void delaySliderMouseDragged(java.awt.event.MouseEvent evt) {
        delayValue.setText(Integer.toString(delaySlider.getValue()));
    }

    private void speedSliderMouseDragged(java.awt.event.MouseEvent evt) {
        speedValue.setText(Integer.toString(speedSlider.getValue()));
    }

    private void stopButtonMouseClicked(java.awt.event.MouseEvent evt) {
        scanmap_link.isrunning=false;
    }

    private void forwardButtonMouseClicked(java.awt.event.MouseEvent evt) {

        if (scanmap_link.packet_num < scanmap_link.packetDatabase.getPacketCount()){
            scanmap_link.donext=true;
        }
    }

    private void playButtonMouseClicked(java.awt.event.MouseEvent evt) {

        if (pauseButton.isSelected()) {
            scanmap_link.view3d.play();
            pauseButton.setSelected(false);
        }

        scanmap_link.isrunning=true;
    }

    private void reverseButtonMouseClicked(java.awt.event.MouseEvent evt) {
        if (scanmap_link.packet_num>1)
            scanmap_link.packet_num-=1;
            String packet_text = Integer.toString(scanmap_link.packet_num+1);
            packet_text = packet_text.concat(" of ");
            packet_text = packet_text.concat(Integer.toString(scanmap_link.packet_count));
            packetNumber.setText( packet_text);
    }

    /** Exit the Application */
    public void exitForm(java.awt.event.WindowEvent evt) {
      scanmap_link.exitForm(evt);
//        System.exit(0);
    }


    private javax.swing.JButton clearButton1;
    private javax.swing.JLabel speedLabel;
    private javax.swing.JPanel timePanel;
    public javax.swing.JTextArea worldTime;
    private javax.swing.JPanel worldTimePanel;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel controlPanel;
    private javax.swing.JLabel delayLabel;
    private javax.swing.JLabel intervalValue;
    private javax.swing.JSlider delaySlider;
    private javax.swing.JButton playButton;
    private javax.swing.JLabel worldTimeLabel;
    private javax.swing.JPanel delayPanel;
    private javax.swing.JButton stopButton;
    public static javax.swing.JCheckBox dnslookup;
    private javax.swing.JPanel packetTimePanel;
    private javax.swing.JPanel intervalPanel;
    private javax.swing.JPanel speedPanel;
    private javax.swing.JButton reverseButton;
    public static javax.swing.JCheckBox byPort;
    public static javax.swing.JCheckBox filter;
    private javax.swing.JSlider speedSlider;
    private javax.swing.JToggleButton pauseButton;
    public javax.swing.JTextArea packetTime;
    private javax.swing.JButton quitButton;
    private javax.swing.JLabel intervalLabel;
    public static javax.swing.JCheckBox linksButton;
    private javax.swing.JSlider intervalSlider;
    private javax.swing.JLabel packetTimeLabel;
    private javax.swing.JButton forwardButton;
    public static javax.swing.JCheckBox byHost;
    private javax.swing.JLabel speedValue;
    private javax.swing.JLabel delayValue;
    private javax.swing.JButton resetButton;
    private javax.swing.JButton filterButton;
    public javax.swing.JTextPane packetNumber;
    private javax.swing.JPanel buttonPanel;
    public static javax.swing.JCheckBox packetsButton;
    private javax.swing.JPanel sliderPanel;
    private javax.swing.JPanel switchPanel;
    private javax.swing.JPanel countPanel;

}
